@CSOURCE8 = /*****************************************************/<R>
/* -- Program to kill any application possessing a   */<R>
/*    visible window the user can pick with the      */<R>
/*    mouse.                                         */<R>
/*****************************************************/<R>
<R>
#include <<windows.h>><R>
#include "killer.h"<R>
<R>
/* Globals. */<R>
HINSTANCE   hins;       /* Instance of this app. */<R>
TIMERPROC   lpfnTimer;  /* Timer proc instance. */<R>
<R>
/* Prototypes. */<R>
BOOL CALLBACK KillerDlg(HWND, UINT, WPARAM, LPARAM);<R>
void          KillWnd(HWND);<R>
void CALLBACK TimerProc(HWND, UINT, UINT, DWORD);<R>
<R>
int CALLBACK<R>
WinMain(HINSTANCE hinsThis, HINSTANCE hinsPrev,<R>
  LPSTR lszCommand, int wShowWindow)<R>
/*****************************************************/<R>
/* -- Entry point.                                   */<R>
/*****************************************************/<R>
    {<R>
    DLGPROC lpfnDialog;<R>
<R>
    hins = hinsThis;<R>
<R>
    /* Create a dialog instead of a main window. */<R>
    /* No need to register a class this way. */<R>
    if ((lpfnDialog = (DLGPROC)MakeProcInstance(<R>
      (FARPROC)KillerDlg, hinsThis)) == (DLGPROC)NULL)<R>
        return FALSE;<R>
<R>
    DialogBox(hinsThis, "Killer", NULL, lpfnDialog);<R>
<R>
    FreeProcInstance((FARPROC)lpfnDialog);<R>
    return TRUE;<R>
    }<R>
<R>
BOOL CALLBACK<R>
KillerDlg(HWND hwnd, UINT wm, WPARAM wParam,<R>
  LPARAM lParam)<R>
/*****************************************************/<R>
/* -- Dialog proc for killing other apps.            */<R>
/*****************************************************/<R>
    {<R>
    static  HWND    hwndPick;<R>
<R>
    switch (wm)<R>
        {<R>
    default:<R>
        return FALSE;<R>
<R>
    case WM_INITDIALOG:<R>
        {<R>
        RECT    rect;<R>
        int     dx  = GetSystemMetrics(SM_CXSCREEN);

@CSOURCE8 =         int     dy  = GetSystemMetrics(SM_CYSCREEN);<R>
<R>
        /* Center the dialog on the screen. */<R>
        GetWindowRect(hwnd, &rect);<R>
        SetWindowPos(hwnd, NULL,<R>
          (dx - (rect.right - rect.left)) / 2,<R>
          (dy - (rect.bottom - rect.top)) / 2,<R>
          0, 0, SWP_NOSIZE | SWP_NOZORDER);<R>
<R>
        /* Start with focus on the pick PushButton. */<R>
        SetFocus(GetDlgItem(hwnd, didPick));<R>
        }<R>
        return FALSE;<R>
<R>
    case WM_COMMAND:<R>
        switch (wParam)<R>
            {<R>
        default:<R>
            return FALSE;<R>
<R>
        case didPick:<R>
            /* Capture the mouse so that we can */<R>
            /* click on another app's window and get */<R>
            /* a message. */<R>
            SetCapture(hwnd);<R>
<R>
            /* Let the user know we are in "pick" */<R>
            /* mode. */<R>
            SetCursor(LoadCursor(NULL, IDC_UPARROW));<R>
            break;<R>
<R>
        case didKill:<R>
            if (IsWindow(hwndPick))<R>
                {<R>
                /* Do our thing! */<R>
                SetDlgItemText(hwnd, didWindow, NULL);<R>
                KillWnd(hwndPick);<R>
                }<R>
            break;<R>
<R>
        case IDCANCEL:<R>
            /* We will get this when the user picks */<R>
            /* "Close" on our system menu. */<R>
            EndDialog(hwnd, FALSE);<R>
            break;<R>
            }<R>
        break;<R>
<R>
    case WM_LBUTTONDOWN:<R>
        {<R>
        POINT   pt;<R>
        char    szBuf[10];<R>
<R>
        if (GetCapture() != hwnd)<R>
            return FALSE;   /* Wasn't in pick mode. */<R>
<R>
        ReleaseCapture();<R>
        SetCursor(LoadCursor(NULL, IDC_ARROW));<R>
<R>
        /* Pick the window under the cursor. */

@CSOURCE8 =         GetCursorPos(&pt);<R>
        hwndPick = WindowFromPoint(pt);<R>
<R>
        /* Get the topmost ancestor of the window */<R>
        /* picked. */<R>
        for (;;)<R>
            {<R>
            HWND    hwndParent;<R>
<R>
            if ((hwndParent = GetParent(hwndPick)) ==<R>
              NULL)<R>
                break;<R>
<R>
            hwndPick = hwndParent;<R>
            }<R>
<R>
        /* Let the user know which window has been */<R>
        /* picked. */<R>
        wsprintf(szBuf, "%x", (UINT)hwndPick);<R>
        SetDlgItemText(hwnd, didWindow, szBuf);<R>
        }<R>
        break;<R>
        }<R>
<R>
    return TRUE;<R>
    }<R>
<R>
void<R>
KillWnd(HWND hwnd)<R>
/*****************************************************/<R>
/* -- Kill the given window handle.                  */<R>
/*****************************************************/<R>
    {<R>
    if (lpfnTimer != NULL)<R>
        return; /* A kill is already pending. */<R>
<R>
    if ((lpfnTimer = (TIMERPROC)MakeProcInstance(<R>
      (FARPROC)TimerProc, hins)) == NULL)<R>
        return;<R>
<R>
    PostMessage(hwnd, WM_TIMER, 0, (LPARAM)lpfnTimer);<R>
    /* Note that we can't free the proc instance */<R>
    /* handle here since this the target app hasn't */<R>
    /* received the message yet.  So we free it in */<R>
    /* the callback. */<R>
    }<R>
<R>
void CALLBACK<R>
TimerProc(HWND hwnd, UINT wm, UINT wParam,<R>
  DWORD lParam)<R>
/*****************************************************/<R>
/* -- Timer callback.                                */<R>
/* -- Destroy the window timer message was sent to.  */<R>
/*****************************************************/<R>
    {<R>
    FreeProcInstance((FARPROC)lpfnTimer);<R>
    lpfnTimer = NULL;<R>
    DestroyWindow(hwnd);<R>
    }<R>


@CSOURCE8 = <R>
/* End of File */ 

