; Copyright (C)  Michael Holzrichter 1992,  All rights reserved.

        title   VDPROD.ASM:  Find Sum of Elements of Vector
        page    55,132

; Call with:    vdprod (float* a, int str_a, float* b, int str_b, float* c, int n)
;
; Returns:      b = Sum (a [i * str_a]* b [i * str_b]) for i = 0 to n-1
;
; Destroys:     nothing

.286
.287

;.MODEL SMALL
.MODEL LARGE
.CODE

N_ELM     equ     bp+6
C_OFF     equ     bp+8
C_SEG     equ     bp+10
B_STR     equ     bp+12
B_OFF     equ     bp+14
B_SEG     equ     bp+16
A_STR     equ     bp+18
A_OFF     equ     bp+20
A_SEG     equ     bp+22

          PUBLIC  _vdprod__FPfiPfiPfi

_vdprod__FPfiPfiPfi PROC
          push    bp                      ; Entry sequence - save old BP
          mov     bp,sp                   ; Set stack framepointer

          push    si                      ; Save registers
          push    ds

          push    cx
          push    bx

          mov     cx, [N_ELM]             ; Get number of elements

          cmp     cx, 0                   ; Check for positive vector length
          jng     error

          mov     si, [A_OFF]             ; Get address of A array
          mov     ds, [A_SEG]

          mov     di, [B_OFF]             ; Get address of B array
          mov     es, [B_SEG]

          mov     ax, 4                   ; Compute stride
          mul     word ptr [B_STR]
          mov     bx, ax

          mov     ax, 4                   ; Compute stride
          mul     word ptr [A_STR]

          fldz

loop1:    fld     dword ptr ds:[si]       ; Load element from A array
          fmul    dword ptr es:[di]       ; Multiply by element from B array

          fadd                            ; Add element

          add     si, ax                  ; Increment pointers
          add     di, bx

          loop    loop1                   ; Repeat until cx is 0

          fwait                           ; Wait for processor to catch up

          mov     si, [C_OFF]             ; Save Result
          mov     ds, [C_SEG]

          fstp    dword ptr ds:[si]

          xor     ax, ax                  ; Return code is 0

exit:     pop     bx                      ; Restore registers
          pop     cx

          pop     ds
          pop     si

          pop     bp

          RET     18                      ; Return

error:    mov     ax, 1
          jmp     exit

_vdprod__FPfiPfiPfi ENDP
          END

