        title   VINIT.ASM Initialize Numeric Coprocessor
        page    55,132

; Call with:    init (int n)
;
; Returns:      0 = initialization succeeded
;              ~0 = initialization failed
;
; Destroys:     nothing

;************************************************************************
; This function is an adaptation of an initialization function appearing
; in an article by Ray Duncan in the Jan. 16, 1990 issue of PC Magazine.
;************************************************************************

;.MODEL SMALL
.MODEL LARGE
.CODE

          PUBLIC  _vinit__Fi

PARM      equ     bp+6

_vinit__Fi PROC
          push    bp                      ; Entry sequence - save old BP
          mov     bp, sp                  ; Set stack framepointer

          push    bx

          mov     bx, 0FFFFH              ; Put FFFFH on stack
          push    bx

          mov     bx, sp

          finit                           ; Try to initialize coprocessor
          fstsw   ss:[bx]                 ; Try to get status word
        
          pop     ax                      ; If low 8 bits are zero,
          or      al, al                  ; Coprocessor is present

          jnz     exit                    ; Jump if no coprocessor

          xor     ax, ax                  ; Zero ax

          fldcw   ss:[PARM]               ; Load coprocessor control word

exit:     pop     bx                      ; Restore registers
          pop     bp

          RET     2                       ; Return

_vinit__Fi ENDP
          END

