; Copyright (C)  Michael Holzrichter 1992,  All rights reserved.

        title   VMOVE.ASM:  Move A Vector
        page    55,132

; Call with:    vmove (float* a, int str_a, float* b, int str_b, int n);
;
; Returns:      b [i*str_b] = a [i*str_a] for i = 0 to n-1
;
; Destroys:     nothing

.286
.287

;.MODEL SMALL
.MODEL LARGE
.CODE

N_ELM     equ     bp+6
B_STR     equ     bp+8
B_OFF     equ     bp+10
B_SEG     equ     bp+12
A_STR     equ     bp+14
A_OFF     equ     bp+16
A_SEG     equ     bp+18

          PUBLIC  _vmove__FPfiPfii

_vmove__FPfiPfii PROC
          push    bp                      ; Entry sequence - save old BP
          mov     bp,sp                   ; Set stack framepointer

          push    di                      ; Save registers
          push    es
          push    si
          push    ds

          push    dx
          push    cx
          push    bx

          mov     cx, [N_ELM]             ; Get number of elements

          cmp     cx, 0                   ; Check for positive vector length
          jng     error

          mov     si, [A_OFF]             ; Get address of A array
          mov     ds, [A_SEG]

          mov     di, [B_OFF]             ; Get address of B array
          mov     es, [B_SEG]

          mov     ax, [A_STR]             ; Compute stride of A array
          dec     ax
          shl     ax, 2
          mov     bx, ax

          mov     ax, [B_STR]            ; Compute stride of B array
          dec     ax
          shl     ax, 2
          mov     dx, ax

          cld                             ; Make sure SI and DI are incremented

loop1:    movsw                           ; Move first pair of bytes
          movsw                           ; Move second pair of bytes

          add     si, bx                  ; Increment pointers
          add     di, dx

          loop    loop1                   ; Repeat until cx is 0

          xor     ax, ax                  ; Zero return code

exit:     pop     bx                      ; Restore registers
          pop     cx
          pop     dx

          pop     ds
          pop     si
          pop     es
          pop     di

          pop     bp

          RET     14                      ; Return

error:    mov     ax, 1
          jmp     exit

_vmove__FPfiPfii ENDP
          END
