#include <windows.h>
#include <string.h>
#include "rc.h"



int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
    LPSTR lpstrCmdLine, int iCmdShow);


BOOL InitApplication(HINSTANCE hInst);

HWND InitInstance(HINSTANCE hInst, int iCmdShow);

LRESULT CALLBACK WndProc(HWND hWnd, UINT uiMsg,
    WPARAM wParam, LPARAM lParam);

BOOL CALLBACK DlgProc(HWND hDlg, UINT uiMsg,
    WPARAM wParam, LPARAM lParam);


BOOL DlgLook(HWND hDlg, unsigned uiMsg, WORD wParam,
    LONG lParam);



/*  GLOBAL VARIABLES */
/*  ---------------- */
    HINSTANCE   ghInst;
    char        gszAppName[] = "DlgLook";
    HWND        ghWndMain;


/*========================================================================*\
|
|   WinMain
|
\*========================================================================*/
#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(
    HINSTANCE   hInst,
    HINSTANCE   hPrevInst,
    LPSTR       lpstrCmdLine,
    int         iCmdShow)
    {
    MSG         msg;

    if (hPrevInst == NULL)
        {
        if (! InitApplication (hInst))
            return (FALSE);
        }

    ghWndMain = InitInstance (hInst, iCmdShow);
    if (! ghWndMain)
        return (FALSE);

    while (GetMessage (&msg, 0, 0, 0))
        {
        TranslateMessage (&msg);
        DispatchMessage (&msg);
        }

    return (msg.wParam);
    }


/*========================================================================*\
|
|   InitApplication
|
|   Initializes application by registering class
|
\*========================================================================*/
BOOL InitApplication(
    HINSTANCE   hInst)
    {
    WNDCLASS    wc;

    wc.style         = 0;
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInst;
    wc.hIcon         = LoadIcon (hInst, MAKEINTRESOURCE (ICO_MAIN));
    wc.hCursor       = LoadCursor (NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject (WHITE_BRUSH);
    wc.lpszMenuName  = MAKEINTRESOURCE (MNU_MAIN);
    wc.lpszClassName = gszAppName;

    return (RegisterClass (&wc));
    }


/*========================================================================*\
|
|   InitInstance
|
|   Initializes this instance of the application
|
\*========================================================================*/
HWND InitInstance(
    HINSTANCE   hInst,
    int         iCmdShow)
    {
    HWND        hWnd;


    ghInst = hInst;

    hWnd = CreateWindow(
        gszAppName,
        gszAppName,
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        NULL,
        NULL,
        hInst,
        NULL);

    if (!hWnd)
        return (NULL);

    ShowWindow (hWnd, iCmdShow);
    UpdateWindow (hWnd);

    return (hWnd);
    }


/*========================================================================*\
|
|   WndProc
|
\*========================================================================*/
#ifdef __BORLANDC__
    #pragma argsused
#endif
LRESULT CALLBACK WndProc(
    HWND    hWnd,
    UINT    uiMsg,
    WPARAM  wParam,
    LPARAM  lParam)
    {


    switch (uiMsg)
        {
        case WM_COMMAND:
            switch (wParam)
                {
                case IDM_EXIT:
                    DestroyWindow (hWnd);
                    break;

                case IDM_DIALOG:
                    DialogBox (ghInst, MAKEINTRESOURCE (DLG_MAIN), hWnd,
                        DlgProc);
                    break;
                }
            break;

        case WM_DESTROY:
            PostQuitMessage (0);
        }

    return (DefWindowProc (hWnd, uiMsg, wParam, lParam));
    }


#ifdef __BORLANDC__
    #pragma argsused
#endif
BOOL CALLBACK DlgProc(
    HWND    hDlg,
    UINT    uiMsg,
    WPARAM    wParam,
    LPARAM    lParam)
    {
    BOOL        bRtn = FALSE;

    if ((bRtn = DlgLook (hDlg, uiMsg, wParam, lParam)) != FALSE)
           return (bRtn);
    switch (uiMsg)
        {
        case WM_INITDIALOG:
            /* because DlgLook handles WM_INITDIALOG, we must */
            /* return TRUE here for proper focus setup        */
            bRtn = TRUE;
            break;
        case WM_COMMAND:
            switch (wParam)
                {
                case IDCANCEL:
                case IDOK:
                    EndDialog (hDlg, TRUE);
                    bRtn = TRUE;
                    break;
                }
            break;
        }
    return (bRtn);
    }

