#include "biglb.h"
#ifdef __BORLANDC__
    #pragma hdrstop
    #paragma argsused

HINSTANCE ModuleInstance;

int FAR PASCAL LibMain(HINSTANCE hInst, WORD wDataSeg,
                    WORD cbHeap, LPSTR lpszCmdLine)
{
  GLOBALHANDLE hWC;
  LPWNDCLASS lpwc;
  BOOL class_found = FALSE;
  char wrk[16];

  ModuleInstance    = hInst;
  if (cbHeap > 0)
    UnlockData(0);

  hWC = GlobalAlloc(GHND, sizeof(WNDCLASS));
  if (hWC != NULL)
  {
    lpwc = (LPWNDCLASS) GlobalLock(hWC);
    if (lpwc != NULL)
    {
      /* set up the control class */
      lpwc->style = CS_HREDRAW | CS_VREDRAW |
                    CS_GLOBALCLASS | CS_DBLCLKS;
      lpwc->lpfnWndProc = (WNDPROC) BigLBWndFn;
      lpwc->cbClsExtra = 0;
      /* reserve extra bytes for memory management */
      lpwc->cbWndExtra = EXTRA_WND_BYTES;
      lpwc->hInstance = hInst;
      lpwc->hIcon = NULL;
      lpwc->hCursor = NULL;
      lpwc->hbrBackground = NULL;
      lpwc->lpszMenuName = NULL;
      LoadString(hInst, IDS_CONTROL_NAME, (LPSTR)&wrk, 16);
      lpwc->lpszClassName = (LPSTR) wrk;
      class_found = (RegisterClass(lpwc) != NULL);
      GlobalUnlock(hWC);
    }
    GlobalFree(hWC);  /* free the space... */
  }
  return (class_found);
}


GLOBALHANDLE WINAPI _export BigLBInfo(void)
{
   GLOBALHANDLE hCtlInfo = NULL;
   LPCTLINFO lpCtlInfo;
   WORD wNumTypes;

   if ((hCtlInfo = GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,
                    (DWORD) sizeof(CTLINFO))) == NULL)
      return NULL;
   lpCtlInfo = (LPCTLINFO) GlobalLock(hCtlInfo);
   lpCtlInfo->wVersion  = 0x0100;
   /* Initialize wCtlTypes to zero */
   lpCtlInfo->wCtlTypes = 0;
   LoadString(ModuleInstance, IDS_CONTROL_NAME,
              (LPSTR) &lpCtlInfo->szClass, CTLCLASS);
   LoadString(ModuleInstance, IDS_CONTROL_NAME,
              (LPSTR)&lpCtlInfo->szTitle, CTLTITLE);
   wNumTypes = lpCtlInfo->wCtlTypes;
   /* checking for too many control types */
   if (wNumTypes == CTLTYPES)
   {
    GlobalUnlock(hCtlInfo);
    return hCtlInfo;
   }
   lpCtlInfo->Type[wNumTypes].wType   = 0;
   /* default size if dialog editor */
   lpCtlInfo->Type[wNumTypes].wWidth  = 48; 
   lpCtlInfo->Type[wNumTypes].wHeight = 48;
   lpCtlInfo->Type[wNumTypes].dwStyle = 
      BIGLB_DEFAULT_STYLE; /* default style bits */
   LoadString(ModuleInstance, IDS_CONTROL_NAME, (LPSTR)
         &lpCtlInfo->Type[wNumTypes].szDescr, CTLDESCR);
   lpCtlInfo->wCtlTypes++;
   GlobalUnlock(hCtlInfo);
   return hCtlInfo;
}

#ifdef __BORLANDC__
    #pragma argsused
#endif
WORD WINAPI _export BigLBFlags(DWORD dwFlags,
               LPSTR szString, WORD wMaxString)
{
  WORD i;

  /* assume the the buffer will never overflow */
  *szString = '\0';
  if ((dwFlags & LBS_STANDARD) == LBS_STANDARD)
    LoadString(ModuleInstance, IDS_STAND,
               &szString[lstrlen(szString)],25);
  else
    {
      if ((dwFlags & LBS_NOTIFY) == LBS_NOTIFY)
        LoadString(ModuleInstance, IDS_NOTIFY,
                   &szString[lstrlen(szString)],25);
      if ((dwFlags & LBS_SORT) == LBS_SORT)
        LoadString(ModuleInstance, IDS_SORT,
                   &szString[lstrlen(szString)],25);
    }
  if ((dwFlags & LBS_NOREDRAW) == LBS_NOREDRAW)
    LoadString(ModuleInstance, IDS_REDRAW,
               &szString[lstrlen(szString)],25);
  if ((dwFlags & LBS_USETABSTOPS) == LBS_USETABSTOPS)
    LoadString(ModuleInstance, IDS_LBTS,
               &szString[lstrlen(szString)],25);
  if ((dwFlags & LBS_NOINTEGRALHEIGHT) == LBS_NOINTEGRALHEIGHT)
    LoadString(ModuleInstance, IDS_INTEG,
               &szString[lstrlen(szString)],25);
  if ((dwFlags & LBS_MULTICOLUMN) == LBS_MULTICOLUMN)
    LoadString(ModuleInstance, IDS_MULTIC,
               &szString[lstrlen(szString)],25);
  if ((dwFlags & LBS_WANTKEYBOARDINPUT) == LBS_WANTKEYBOARDINPUT)
    LoadString(ModuleInstance, IDS_KEYB,
               &szString[lstrlen(szString)],25);
/* this style is Windows 3.0a and above */
#if (WINVER > 0x0300)
  if ((dwFlags&LBS_DISABLENOSCROLL) == LBS_DISABLENOSCROLL)
    LoadString(ModuleInstance, IDS_LBSB,
               &szString[lstrlen(szString)],25);
#endif

/* hack off the trailing " | " */
  i = lstrlen(szString);  
  if (i > 0)
    i -= 2;
  szString[i] = 0;
  return i;
}


BOOL WINAPI _export BigLBStyle(HWND hWnd, GLOBALHANDLE
hCtlStyle, LPFNSTRTOID lpfnSTRtoID, LPFNIDTOSTR lpfnIDtoSTR)
{
  LOCALHANDLE hCtlStyleDlg;
  NPCTLSTYLEDLG npCtlStyleDlg;
  BOOL bResult;
  char wrk[16];

  if ((hCtlStyleDlg=LocalAlloc(LMEM_MOVEABLE|LMEM_ZEROINIT,
                       sizeof(CTLSTYLEDLG))) == NULL)
    return FALSE;
  npCtlStyleDlg = (NPCTLSTYLEDLG)LocalLock(hCtlStyleDlg);
  npCtlStyleDlg->hCtlStyle = hCtlStyle;
  npCtlStyleDlg->lpfnStrToId = lpfnSTRtoID;
  npCtlStyleDlg->lpfnIdToStr = lpfnIDtoSTR;
  LocalUnlock(hCtlStyleDlg);
  /*    associate the CLTSTYLEDLG structure with this
   *    window (the dialog editor) via a string     */
  SetProp(hWnd, MAKEINTRESOURCE(IDS_CTL_PROP), hCtlStyleDlg);

  /* popup the sytle dialog box */
  LoadString(ModuleInstance,BIGLB_STYLE_DLG,(LPSTR)&wrk,16);
  bResult = DialogBoxParam(ModuleInstance, (LPSTR)wrk, hWnd,
             (DLGPROC) BigLBDlgFn, NULL);
  /* clean up property lists */
  RemoveProp(hWnd, MAKEINTRESOURCE(IDS_CTL_PROP));
  LocalFree(hCtlStyleDlg);
  return bResult;
}

LPCTLSTYLE WINAPI CtlStyleLock(HWND hDlg)
{
   LOCALHANDLE hCtlStyleDlg;
   NPCTLSTYLEDLG npCtlStyleDlg;
   LPCTLSTYLE lpCtlStyle;

   if ((hCtlStyleDlg=(LOCALHANDLE)GetProp(GetParent(hDlg),
           MAKEINTRESOURCE(IDS_CTL_PROP))) == NULL)
     return NULL;
   npCtlStyleDlg = (NPCTLSTYLEDLG)LocalLock(hCtlStyleDlg);
   lpCtlStyle = (LPCTLSTYLE)
        GlobalLock(npCtlStyleDlg->hCtlStyle);
   LocalUnlock(hCtlStyleDlg);
   return lpCtlStyle;
}

void WINAPI CtlStyleUnlock(HWND hDlg)
{
   LOCALHANDLE hCtlStyleDlg;
   NPCTLSTYLEDLG npCtlStyleDlg;

   if ((hCtlStyleDlg = GetProp(GetParent(hDlg),
              MAKEINTRESOURCE(IDS_CTL_PROP))) == NULL)
      return;
   npCtlStyleDlg = (NPCTLSTYLEDLG)LocalLock(hCtlStyleDlg);
   GlobalUnlock(npCtlStyleDlg->hCtlStyle);
   LocalUnlock(hCtlStyleDlg);
}


WORD WINAPI GetIDString(HWND hDlg,LPSTR szId,WORD wIdMaxLen)
{
   LOCALHANDLE hCtlStyleDlg;
   NPCTLSTYLEDLG npCtlStyleDlg;
   LPCTLSTYLE lpCtlStyle;
   WORD wIdLen;

   /*   Property is associated with Dialog Editor's window.
    *   Parent of the dialog box is the Dialog Editor.   */
   if ((hCtlStyleDlg = (LOCALHANDLE)GetProp(GetParent(hDlg),
                 MAKEINTRESOURCE(IDS_CTL_PROP))) == NULL)
     return 0;
   npCtlStyleDlg = (NPCTLSTYLEDLG)LocalLock(hCtlStyleDlg);
   lpCtlStyle = (LPCTLSTYLE)
                GlobalLock(npCtlStyleDlg->hCtlStyle);
   wIdLen = (*npCtlStyleDlg->lpfnIdToStr)
              (lpCtlStyle->wId, szId, wIdMaxLen);
   GlobalUnlock(npCtlStyleDlg->hCtlStyle);
   LocalUnlock(hCtlStyleDlg);
   return wIdLen;
}


DWORD WINAPI SetIDValue(HWND hDlg, LPSTR szId)
{
   LOCALHANDLE hCtlStyleDlg;
   NPCTLSTYLEDLG npCtlStyleDlg;
   LPCTLSTYLE lpCtlStyle;
   DWORD dwResult = 0;

   if ((hCtlStyleDlg=(LOCALHANDLE)GetProp(GetParent(hDlg),
                 MAKEINTRESOURCE(IDS_CTL_PROP))) == NULL )
      return NULL;
   npCtlStyleDlg = (NPCTLSTYLEDLG)LocalLock(hCtlStyleDlg);
   dwResult = (*npCtlStyleDlg->lpfnStrToId)(szId);
   LocalUnlock(hCtlStyleDlg);
   /* If LOWORD is zero, string NOT found. */
   if (LOWORD(dwResult) == 0)
      return dwResult;
   /* LOWORD is not zero, numeric ID is in the HIWORD. */
   lpCtlStyle = CtlStyleLock(hDlg);
   lpCtlStyle->wId = HIWORD(dwResult);
   CtlStyleUnlock(hDlg);
   return dwResult;
}


BOOL IDtoStyleBits(int id,DWORD style)
{
  switch (id)
  {
    case ID_NOTIFY :
        return (BOOL) ((style & LBS_NOTIFY) != 0);
    case ID_SORT :
        return (BOOL) ((style & LBS_SORT) != 0);
    case ID_MULTIC :
        return (BOOL)((style & LBS_MULTICOLUMN) != 0);
    case ID_REDRAW :
        return (BOOL) ((style & LBS_NOREDRAW) != 0);
    case ID_LBTS :
        return (BOOL) ((style & LBS_USETABSTOPS) != 0);
    case ID_INTEG :
        return (BOOL) ((style&LBS_NOINTEGRALHEIGHT) == 0);
    case ID_KEYB:
        return (BOOL)((style&LBS_WANTKEYBOARDINPUT) != 0);
#if (WINVER > 0x0300)
    case ID_LBSB:
        return (BOOL) ((style & LBS_DISABLENOSCROLL) != 0);
#endif
    case ID_ATTS :
        return (BOOL) ((style & WS_TABSTOP ) != 0);
    case ID_GROUP :
        return (BOOL) ((style & WS_GROUP ) != 0);
    case ID_VIS :
        return (BOOL) ((style & WS_VISIBLE ) != 0);
    case ID_DISA :
        return (BOOL) ((style & WS_DISABLED ) != 0);
    case ID_BORDER :
        return (BOOL) ((style & WS_BORDER ) != 0);
    case ID_HORZSB :
        return (BOOL) ((style & WS_HSCROLL ) != 0);
    case ID_VERTSB :
        return (BOOL) ((style & WS_VSCROLL ) != 0);
    default      : return (FALSE);
  } 
}


void SetIDStyleBits(int id,LPDWORD style)
{
  switch (id)
  {
    case ID_NOTIFY  : (*style) |= LBS_NOTIFY;
                      break;
    case ID_SORT    : (*style) |= LBS_SORT;
                      break;
    case ID_MULTIC  : (*style) |= LBS_MULTICOLUMN;
                      break;
    case ID_REDRAW  : (*style) |= LBS_NOREDRAW;
                      break;
    case ID_LBTS    : (*style) |= LBS_USETABSTOPS;
                      break;
    case ID_INTEG: (*style) &= ~LBS_NOINTEGRALHEIGHT;
                      break;
    case ID_KEYB: (*style) |= LBS_WANTKEYBOARDINPUT;
                      break;
#if (WINVER > 0x0300)
    case ID_LBSB  : (*style) |= LBS_DISABLENOSCROLL;
                    break;
#endif
    case ID_ATTS   : (*style) |= WS_TABSTOP;
                     break;
    case ID_GROUP  : (*style) |= WS_GROUP;
                     break;
    case ID_VIS    : (*style) |= WS_VISIBLE;
                     break;
    case ID_DISA   : (*style) |= WS_DISABLED;
                     break;
    case ID_BORDER : (*style) |= WS_BORDER;
                     break;
    case ID_HORZSB : (*style) |= WS_HSCROLL;
                     break;
    case ID_VERTSB : (*style) |= WS_VSCROLL;
                     break;
    default        : (*style) |= WS_CHILD;
                     break;
  }
}


#ifdef __BORLANDC__
    #pragma argsused
#endif
BOOL CALLBACK _export BigLBDlgFn(HWND hDlg,
             UINT msg, WPARAM wParam, LPARAM lParam)
{
  char szID[20];
  DWORD dwResult;
  LPCTLSTYLE lpCtlStyle;
  int i;
  BOOL state;

  switch (msg)
  {
    case WM_INITDIALOG  :
            GetIDString(hDlg,szID,20);
            SetDlgItemText(hDlg,ID_IDNAME,szID);
            /* lock the property resource */
            lpCtlStyle = CtlStyleLock(hDlg);
            for (i=ID_NOTIFY; i <= ID_HORZSB; i++)
            {
                /* set the state of the checkboxes */
                  state = IDtoStyleBits(i,
                             (lpCtlStyle->dwStyle));
                  SendDlgItemMessage(hDlg, i, BM_SETCHECK,
                                     state, NULL);
            }
            CtlStyleUnlock(hDlg);
            return (FALSE);
    case WM_COMMAND :
            if (wParam == ID_IDNAME)
               if (HIWORD(lParam) == EN_CHANGE)
               {
                  EnableWindow(GetDlgItem(hDlg,IDOK),
                      SendMessage((HWND) LOWORD(lParam),
                          WM_GETTEXTLENGTH, NULL, NULL)
                          ? TRUE : FALSE);
                  break;
                }
            if (wParam == IDCANCEL)
            {
                EndDialog(hDlg,wParam);
                break;
            }
            if (wParam == IDOK)
            {
                GetDlgItemText(hDlg,ID_IDNAME,szID,20);
                dwResult = SetIDValue(hDlg,szID);
                /* check validity of ID */
                if (LOWORD(dwResult) == 0)
                {
                   MessageBeep(MB_OK);
                   break;
                }
/* get the state of all the buttons, set the style bits */
                dwResult = WS_CHILD;
                for (i=ID_NOTIFY; i <= ID_HORZSB; i++)
                {
                    state = (BOOL)
                        SendDlgItemMessage(hDlg, i,
                             BM_GETCHECK,NULL,NULL);
                    if (state)
                      SetIDStyleBits(i,&dwResult);
                    else
                      if (i == ID_INTEG)
                        dwResult |= LBS_NOINTEGRALHEIGHT;
                }
                lpCtlStyle = CtlStyleLock(hDlg);
                lpCtlStyle->dwStyle = dwResult;
                CtlStyleUnlock(hDlg);
                EndDialog(hDlg,wParam);
                break;
            }
    default  :  return FALSE;
  }
  return (TRUE);
}


