/*
 *
 * Listing # 14 -- LB8192.C
 *
 */


#define NOCOMM

#include <windows.h>

#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "lb8192.h"

#define RANDOM(n) (rand() % RAND_MAX)

/*
 *
 * global vars for tester code...
 *
 */

HINSTANCE ModuleInstance;
HWND hWnd;
HACCEL hAccTable;
char LB8192_NAME[]="LB_8192";
char szBuffer[512];


/* forward function declarations */

LRESULT CALLBACK _export LB8192WindowProc(HWND,
                                          UINT,
                                          WPARAM,
                                          LPARAM);
BOOL CALLBACK _export LB8192AboutProc(HWND,
                                      UINT,
                                      WPARAM,
                                      LPARAM);


void InitLB8192First(HINSTANCE hInstance)
{
      WNDCLASS wcLB8192Class;

      /* set the window class parameters */

      wcLB8192Class.lpszClassName = LB8192_NAME;
      wcLB8192Class.hInstance = hInstance;
      wcLB8192Class.lpfnWndProc =
              (WNDPROC) LB8192WindowProc;
      wcLB8192Class.hCursor = 
              LoadCursor(NULL,IDC_ARROW);
      wcLB8192Class.hIcon =
              LoadIcon(hInstance,"LB8192_ICO");
      wcLB8192Class.lpszMenuName = 
              (LPSTR) "LB8192_MENU";
      wcLB8192Class.hbrBackground =
             (HBRUSH) GetStockObject(WHITE_BRUSH);
      wcLB8192Class.style =
             CS_HREDRAW | CS_VREDRAW;
      wcLB8192Class.cbClsExtra = 0;
      wcLB8192Class.cbWndExtra = 0;

      RegisterClass(&wcLB8192Class);
}



void InitLB8192Every(HINSTANCE hInstance,
                     int cmdShow)
{

    hWnd = CreateWindow(LB8192_NAME,
       LB8192_NAME,
       WS_OVERLAPPEDWINDOW,
       CW_USEDEFAULT,CW_USEDEFAULT,
       CW_USEDEFAULT,CW_USEDEFAULT,
       NULL,
       NULL,
       hInstance,
       NULL);

   ShowWindow(hWnd,cmdShow);
   UpdateWindow(hWnd);

}



#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpszCmdLine,
                   int cmdShow)
{
    MSG msg;

    ModuleInstance  = hInstance;
    if (!hPrevInstance)
      InitLB8192First(hInstance);

    InitLB8192Every(hInstance,cmdShow);

    while (GetMessage(&msg,NULL,NULL,NULL))
    {
     if (TranslateAccelerator(hWnd,hAccTable,&msg))
       continue;

     TranslateMessage(&msg);
     DispatchMessage(&msg);
    }

    return (msg.wParam);
}



void Easy_Yield(void)
{
  MSG msg;

  if (PeekMessage(&msg,NULL,NULL,NULL,PM_REMOVE))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
}


#ifdef __BORLANDC__
    #pragma argsused
#endif
BOOL CALLBACK _export LB8192AboutProc(HWND hDlg,
                                     UINT message,
                                     WPARAM wParam,
                                     LPARAM lParam)
{

  if (message == WM_INITDIALOG)
    return (TRUE);

  if (message == WM_COMMAND)
    if (wParam == IDOK || wParam == IDCANCEL)
      EndDialog(hDlg,TRUE);

  if (message == WM_CLOSE)
    EndDialog(hDlg,TRUE);

  return FALSE;
}


/*
 *
 *  form_20() and number_name() generate
 * something interesting to look at in the listbox
 *
 */

void form_20(int d,LPSTR szBuffer)
{
static char *ones[] =
 { "", "one ", "two ", "three ",
   "four ", "five ", "six ", "seven ",
   "eight ", "nine ", "ten ", "eleven ",
   "twelve ", "thirteen ", "fourteen ",
   "fifteen ", "sixteen ", "seventeen ",
   "eighteen ", "nineteen " };
static char *tens[] = { "", "", "twenty ",
   "thirty ", "forty ", "fifty ", "sixty " ,
   "seventy ", "eighty ", "ninety " };

     if (d >= 20)
     {
      lstrcat(szBuffer,tens[d/10]);
      d -= (d/10) * 10;
     }
     if (d > 0)
     {
      lstrcat(szBuffer,ones[d]);
     }
}


LPSTR number_name(int d,LPSTR szBuffer)
{

  static char hundreds[] = "hundred ";
  static char thousands[] = "thousand ";
  static char zero[] = "zero";
  int i;

  *szBuffer = '\0';

  if ((i = (d / 1000)) > 0)
  {
    form_20(i,szBuffer);
    lstrcat(szBuffer,thousands);
    d -= i* 1000;
  }


  if ((i = (d / 100)) > 0)
  {
    form_20(i,szBuffer);
    lstrcat(szBuffer,hundreds);
    d -= i * 100;
  }

  form_20(d,szBuffer);


  if (*szBuffer == '\0')
    lstrcpy(szBuffer,zero);

  return szBuffer;

}


/*
 *  main window callback function
 */

LRESULT CALLBACK _export
   LB8192WindowProc(HWND hWnd,
                    UINT message,
                    WPARAM wParam,
                    LPARAM lParam)
{

  static HWND hBig_lb;
  static HWND hButton;
  static FARPROC lpfnAboutProc = NULL;
  static closing = FALSE;
  static lb_enable = TRUE;
  static HINSTANCE hLib;
  static HFONT lb_font;

  RECT clRect,lbRect;
  HDC hDC;
  TEXTMETRIC tm;
  PAINTSTRUCT ps;

  LOGFONT lf;
  WORD lb_cursel;

  int i,j;
  LRESULT lresult;
  char wrk[512];


  switch (message)
  {

    case WM_CREATE :
        /* load up the keyboard accelerators */
        hAccTable = LoadAccelerators(
            ModuleInstance,"LB8192_ACCS");

        /* load up the control library */
        if ((hLib = LoadLibrary("BIGLB.DLL"))
              < HINSTANCE_ERROR)
        {
          MessageBox(hWnd,
                    "BIGLB.DLL load failed...",
                    LB8192_NAME,MB_OK);
        }

        GetClientRect(hWnd,&clRect);

        memset(&lf,0,sizeof(LOGFONT));

        /* get system font metrics */
        hDC = GetDC(hWnd);
        GetTextMetrics(hDC,&tm);
        ReleaseDC(hWnd,hDC);

        /* make this font slightly smaller */
        lf.lfHeight = (tm.tmHeight << 2) / 5;
        lstrcpy((LPSTR)lf.lfFaceName,"Helv");

        lb_font = CreateFontIndirect(&lf);

        clRect.bottom = (clRect.bottom -
          tm.tmHeight -
          GetSystemMetrics(SM_CYDLGFRAME));
        clRect.right >>= 1;


        hBig_lb = CreateWindow("BIGLB",
            "",
            WS_CHILD | WS_VISIBLE | LBS_STANDARD |
            LBS_USETABSTOPS|LBS_WANTKEYBOARDINPUT |
            LBS_NOINTEGRALHEIGHT,
            clRect.left,clRect.top,
            clRect.right,clRect.bottom,
            hWnd,
            (HMENU) ID_BIGLB,
            ModuleInstance,
            (VOID FAR *)&lb_font);

        if (hBig_lb == NULL)
        {
          DeleteObject(lb_font);
          if (hLib >= HINSTANCE_ERROR)
            FreeLibrary(hLib);
          MessageBox(hWnd,
             "Failed to create a BIGLISTBOX...",
             LB8192_NAME,MB_OK);
          return -1;
        }

        hButton = CreateWindow("BUTTON",
            "Toggle LB Enable",
            WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
            (clRect.right >> 1)+150,
            (clRect.bottom >> 1)-25,150,50,
            hWnd,
            (HMENU) ID_BEEP,
            ModuleInstance,
            NULL);

        if (hButton == NULL)
        {
          DeleteObject(lb_font);
          DestroyWindow(hBig_lb);
          if (hLib >=  HINSTANCE_ERROR)
            FreeLibrary(hLib);
          MessageBox(hWnd,
            "Failed to create a BUTTON...",
            LB8192_NAME,MB_OK);
          return -1;
        }
        return (FALSE);


    case WM_SIZE :  /* resize the listbox with the
                       window... */
        GetClientRect(hWnd,&clRect);
        hDC = GetDC(hWnd);
        GetTextMetrics(hDC,&tm);
        ReleaseDC(hWnd,hDC);
        MoveWindow(hBig_lb,clRect.left,
                 clRect.top,(clRect.right >> 1),
                 (clRect.bottom - tm.tmHeight - 
                 GetSystemMetrics(SM_CYDLGFRAME)),
                 TRUE);
        MoveWindow(hButton,
                   (clRect.right >> 1)+150,
                   (clRect.bottom >> 1)-25,
                   150,50,TRUE);
        break;

    case WM_SETFOCUS:
        if (IsWindowEnabled(hBig_lb))
            SetFocus(hBig_lb);
        else
            SetFocus(hButton);
        break;


  close_me:
    case WM_CLOSE :
        closing = TRUE;
        DestroyWindow(hBig_lb);
        DestroyWindow(hButton);
        DestroyWindow(hWnd);
        break;


    case WM_DESTROY :
        if (hLib > HINSTANCE_ERROR)
          FreeLibrary(hLib);
        DeleteObject(lb_font);
        DeleteObject(hAccTable);
        PostQuitMessage(0);
        break;


    case WM_COMMAND :
        switch (wParam)
        {

          case ID_BEEP :
              MessageBeep(MB_OK);
              lb_enable = !lb_enable;
              EnableWindow(hBig_lb,lb_enable);
              if (lb_enable)
                SetFocus(hBig_lb);
              break;

          case ID_BIGLB :
              /* LBN_DBLCLK sent by default
                 listbox callback function */
              if (HIWORD(lParam) == LBN_DBLCLK)
              {
                MessageBeep(MB_OK);
                MessageBeep(MB_OK);
              }
              break;

          case ID_ADD :
              j = RANDOM(32767);
              wsprintf(wrk,
                       "%05d\t%s",j,
                  (LPSTR) number_name(j,szBuffer));
              AnsiUpperBuff(wrk,lstrlen(wrk));
              lresult = SendMessage(hBig_lb,
                         LB_ADDSTRING,
                         NULL,(LPARAM)(LPSTR)wrk);
              if (lresult == LB_ERRSPACE)
              {
                MessageBox(hWnd,
                 "ADD_STRING ran out of space.",
                 LB8192_NAME,MB_OK);
                break;
              }
              break;

          case ID_DEL :
              lb_cursel = (WORD)
                  SendMessage(hBig_lb,
                              LB_GETCURSEL,
                              NULL,NULL);
              if (lb_cursel == (WORD) LB_ERR)
              {
                MessageBeep(MB_OK);
                break;
              }
              SendMessage(hBig_lb,
                          LB_DELETESTRING,
                          lb_cursel,NULL);
              break;

          case ID_CLEAR:
              SendMessage(hBig_lb,
                          LB_RESETCONTENT,
                          NULL,NULL);
              break;

          case ID_EXIT:
              goto close_me;

          case ID_ABOUT :
              lpfnAboutProc = MakeProcInstance(
                 (FARPROC) LB8192AboutProc,
                 ModuleInstance);
              DialogBox(ModuleInstance,
                 "LB8192_ABOUT",
                  hWnd,
                  (DLGPROC)lpfnAboutProc);
              FreeProcInstance(lpfnAboutProc);
              break;

          case ID_AUTOGEN :
        /* turn off listbox updating for speed */
              SendMessage(hBig_lb,
                 WM_SETREDRAW,FALSE,NULL);
              i = 0;
              while (i < 32767 && !closing)
              {
                j = RANDOM(32767);
                wsprintf(wrk,
                        "%05d\t%s",j,
                  (LPSTR) number_name(j,szBuffer));
                AnsiUpperBuff(wrk,lstrlen(wrk));
                lresult = SendMessage(hBig_lb,
                            LB_ADDSTRING,
                            NULL,
                            (LPARAM)(LPSTR)wrk);
                if (lresult == LB_ERRSPACE)
                {
                  MessageBox(hWnd,
                   "ADD_STRING ran out of space.",
                   LB8192_NAME,MB_OK);
                  break;
                }
                if (++i % 64 == 0)
                {
                  wsprintf(szBuffer,
                     "LB_8192 (%ld items)",
                     SendMessage(hBig_lb,
                       LB_GETCOUNT,NULL,NULL));
                  SetWindowText(hWnd,
                           (LPSTR)szBuffer);
                  Easy_Yield();
                }
              }
              /* turn listbox update back on... */
              SendMessage(hBig_lb,
                    WM_SETREDRAW,TRUE,NULL);
              break;
        }

        /* form the status line rectangle... */
        GetClientRect(hBig_lb,&lbRect);
        GetClientRect(hWnd,&clRect);
        clRect.top = lbRect.bottom + 
                GetSystemMetrics(SM_CYDLGFRAME);

     /* ask for update and erase of status line */
        InvalidateRect(hWnd,&clRect,TRUE);
        break;

  case WM_PAINT :

        hDC = BeginPaint(hWnd,&ps);
        lresult = SendMessage(hBig_lb,
                    LB_GETCURSEL,NULL,NULL);
        if (lresult == LB_ERR)
          lstrcpy(szBuffer,"No Selection Made...");
        else
          {
            lb_cursel = (WORD) lresult;
            if (SendMessage(hBig_lb,
                   LB_GETTEXT,lb_cursel,
                   (LPARAM)(LPSTR) wrk) != LB_ERR)
            {
              wsprintf(szBuffer,
                      "Current Selection is :\
\tItem number : %u\tString : %s",
                      lb_cursel,(LPSTR) wrk);
            }
          }

 /* get the dimensions of the listbox client area */
        GetClientRect(hBig_lb,&lbRect);
        GetClientRect(hWnd,&clRect);
        clRect.top = lbRect.bottom +
             GetSystemMetrics(SM_CYDLGFRAME);

        DrawText(hDC,(LPSTR)szBuffer,
             lstrlen((LPSTR)szBuffer),
             &clRect,
             DT_LEFT | DT_VCENTER | DT_SINGLELINE |
             DT_EXPANDTABS);

        EndPaint(hWnd,&ps);

        wsprintf(szBuffer,
           "LB_8192 (%ld items)",
           SendMessage(hBig_lb,
              LB_GETCOUNT,NULL,NULL));
        SetWindowText(hWnd,(LPSTR)szBuffer);

        break;

    default :
        return (DefWindowProc(hWnd,
                 message,wParam,lParam));

  }
  return 0L;
}

