#include "biglb.h"
#ifdef __BORLANDC__
#pragma hdrstop
#endif

LRESULT CALLBACK _export BigLB_SubProc(HWND hWnd,
                 UINT msg, WPARAM wParam, LPARAM lParam)
{
  LPSTR lpc;
  LRESULT lresult;
  WORD st,count,org_st,len; 
  BOOL found,wrapped;
  char wrk[2];

  switch (msg)
  {
    case WM_CHAR: 
     /* position in listbox according to keyboard input */
        if (isalnum(wParam) || ispunct(wParam))
        {
            wrk[0] = wParam;
            wrk[1] = 0;
            st = (WORD) SendMessage(hWnd,
                       LB_GETCURSEL,NULL,NULL);
            /* LB_SELECTSTRING will change the
               selection if prefix is found */
            lresult = SendMessage(hWnd, LB_SELECTSTRING,
                      st, (LPARAM) (LPSTR)wrk);
            return (TRUE);
        }
        break;
    case LB_SELECTSTRING:
    case LB_FINDSTRING:
        st = wParam;  /* starting position */
        /*  -1 for start at the beginning... */
        if (st == 0xFFFF) 
          st = 0;
        else
          st++;
        /*  save the value to detect a wrap-around */
        org_st = st; 
        lresult = SendMessage(hWnd, LB_GETCOUNT,NULL,NULL);
        if (lresult == LB_ERR)
          return LB_ERR;
        count = (WORD) lresult;
        found = wrapped = FALSE;
        len = lstrlen((LPSTR) lParam);
        while (!found)
        {
          while (st < count)
          {
            /* fetch a pointer to the start string */
            lresult = CallWindowProc(
                (WNDPROC)GetWindowLong(
                  GetParent(hWnd),GWL_OLDPROC),
                hWnd,LB_GETTEXT,st,(LPARAM)(void FAR *)&lpc);
            if (lresult == LB_ERR)
              return LB_ERR;
            /* this works for COMPACT model, pointers are 
             * the correct width for strncmp()      */
            if (_fstrncmp(lpc,(LPSTR)lParam,len)==0)
            {
              found = TRUE;
              break;
            }
            st++;
          }
          /* wrap the search... */
          if (!wrapped && !found)
          {
            st = 0;
            wrapped = TRUE;
  /* if I wrapped, and I started at the begining */
            if (wParam == 0xFFFF)
                return LB_ERR;
            count = org_st;
          }
          else
            break;  /* no match or found */
        }
        if (wrapped && !found)
          return LB_ERR;    /* not found... */
        /* LB_FINDSTRING does not change the selection */
        if (msg == LB_SELECTSTRING)
        {
           /* generate a notification message */ 
           SendMessage(GetParent(hWnd),
               WM_COMMAND, GetWindowWord(hWnd,GWW_ID),
               MAKELONG(hWnd,LBN_SELCHANGE));
           /* now change the selection LB_SETCURSEL does not
            * generate a notification message */
            SendMessage(hWnd, LB_SETCURSEL, (WORD) st,NULL);
        }
        return (LPARAM) st;  
/* intercept and allocate listbox string space globally */
    case LB_INSERTSTRING :
    case LB_ADDSTRING :
        if ((lpc = (LPSTR) dll_malloc(GetParent(hWnd),
                 lstrlen((LPSTR)lParam)+1L)) == NULL)
          return (LB_ERRSPACE);
        lParam = (LPARAM)lstrcpy(lpc,(LPSTR)lParam);
        break;
    case LB_GETTEXT:
        lresult = CallWindowProc((WNDPROC)GetWindowLong(
                      GetParent(hWnd),GWL_OLDPROC),
                   hWnd,msg,wParam,(LPARAM)(void FAR *)&lpc);
        if (lresult == LB_ERR)
              return LB_ERR;
        lstrcpy((LPSTR)lParam,lpc);
        return lstrlen(lpc);
    case LB_GETTEXTLEN:
        lresult = CallWindowProc((WNDPROC)GetWindowLong(
              GetParent(hWnd),GWL_OLDPROC), hWnd,LB_GETTEXT,
                   wParam,(LPARAM)(void FAR *)&lpc);
        if (lresult == LB_ERR)
          return LB_ERR;
        return (LPARAM) lstrlen(lpc);
  }

  /* call the old LISTBOX callback function to process most
   * of the messages. the old wndproc address is stored in
   * the parent's extra window bytes                    */
  lresult = CallWindowProc((WNDPROC)GetWindowLong(
      GetParent(hWnd),GWL_OLDPROC),hWnd,msg,wParam,lParam);
  if (msg == LB_RESETCONTENT)
    dll_freeall(GetParent(hWnd));
  if (msg == LB_DELETESTRING &&
      SendMessage(hWnd,LB_GETCOUNT,0,0L) == 0L)
      dll_freeall(GetParent(hWnd));
  return lresult;
}
