/*   Title:  IOUTILS.H                               *
 *  Author:  John Reynolds                           *
 * Purpose:  Interface to Analog/Digital I/O being   *
 *           used in this specific system.           *
 * Copyright 1991 Magnetic Technologies Corporation  *
 *           Rochester, New York  14625              */

#ifndef IOUTILS_H
#define IOUTILS_H

/*---- assign digital output bits b0 - b7 ----*/
#define STEP      1   /* step output bit      */
#define DIRECTION 2   /* direction output bit */

/*------ assign digital input bits b0 - b7 ------*/
#define CWLIMIT   6 /* clockwise limit input bit */
#define CCWLIMIT  7 /* countercw limit input bit */
#define MECHHOME  2 /* mechanical home input bit */

#define READS_PER_BLOCK 1000

extern unsigned char digital_reads[READS_PER_BLOCK];
extern unsigned int analog_reads[READS_PER_BLOCK];

int init_io(unsigned char device); /* return 0 = ok */
void turn_on_bit(unsigned char bit);
void turn_off_bit(unsigned char bit);
int read_io(unsigned int stepnum); /* return 0 = ok */
#endif
