-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=Begin Listing 07-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
/*****************************************************/
/* childrag.c                                        */
/* -- Child control dragging demo.                   */
/*****************************************************/

#include <windows.h>
#include <windowsx.h>

#define cidButton 0x0100

char    szApp[]     = "ChilDrag";
char    szButton[]  = "Button";
WNDPROC lpfnSubClass, lpfnSav;

LRESULT CALLBACK    LMainWndProc(HWND, UINT, WPARAM,
                    LPARAM);
LRESULT CALLBACK    LSubClassProc(HWND, UINT, WPARAM,
                    LPARAM);

int PASCAL
WinMain(HINSTANCE hinsThis, HINSTANCE hinsPrev,
  LPSTR lszCommand, int wShowWindow)
/*****************************************************/
/* -- Entry point.                                   */
/*****************************************************/
    {
    HWND        hwnd;   /* Main window. */
    MSG         msg;    /* For message pump. */
    WNDCLASS    wcs;

    if (!hinsPrev)  /* Register classes first time. */
        {
        wcs.style = CS_HREDRAW | CS_VREDRAW;
        wcs.lpfnWndProc = LMainWndProc;
        wcs.cbClsExtra = 0;
        wcs.cbWndExtra = 0;
        wcs.hInstance = hinsThis;
        wcs.hIcon = LoadIcon(NULL, IDI_APPLICATION);
        wcs.hCursor = LoadCursor(NULL, IDC_ARROW);
        wcs.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
        wcs.lpszMenuName = NULL;
        wcs.lpszClassName = szApp;
        if (!RegisterClass(&wcs))
            return 0;
        }

    if (!GetClassInfo(NULL, szButton, &wcs))
        return 0;   /* Something badly wrong. */

    lpfnSav = wcs.lpfnWndProc;
    if (!(lpfnSubClass = (WNDPROC)MakeProcInstance(
      (FARPROC)LSubClassProc, hinsThis)))
        return 0;

    /* Create and show the main window. */
    msg.message = 0;
    if (hwnd = CreateWindow(szApp,
      "Child dragging demo", WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, wShowWindow, CW_USEDEFAULT,
      CW_USEDEFAULT, NULL, NULL, hinsThis, NULL))
        {
        ShowWindow(hwnd, wShowWindow);
        UpdateWindow(hwnd);
        while (GetMessage(&msg, NULL, NULL, NULL))
            {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
            }
        }

    FreeProcInstance((FARPROC)lpfnSubClass);
    return msg.message;
    }

LRESULT CALLBACK
LMainWndProc(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lParam)
/*****************************************************/
/* -- Main window procedure.                         */
/*****************************************************/
    {
    switch (wm)
        {
    default:
        break;

    case WM_CREATE:
        {
        HWND    hwndChild;

        if (!(hwndChild = CreateWindow(szButton,
          "drag me",
          WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
          0, 0, 0, 0, hwnd, (HMENU)cidButton,
          GetWindowInstance(hwnd), NULL)))
            return -1;  /* Destroy main window. */

        SubclassWindow(hwndChild, lpfnSubClass);
        }
        break;

    case WM_SIZE:
        {
        int dx = LOWORD(lParam);
        int dy = HIWORD(lParam);

        SetWindowPos(GetDlgItem(hwnd, cidButton), NULL,
          dx / 4, dy / 4, dx / 2, dy / 2,
          SWP_NOACTIVATE | SWP_NOZORDER);
        }
        break;

    case WM_DESTROY:
        PostQuitMessage(0);
        break;

        }   /* End switch wm. */

    return DefWindowProc(hwnd, wm, wParam, lParam);
    }

LRESULT CALLBACK
LSubClassProc(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lParam)
/*****************************************************/
/* -- Button control subclasser.                     */
/*****************************************************/
    {
    return wm == WM_NCHITTEST &&
        GetKeyState(VK_SHIFT) < 0 ?
      HTCAPTION :
      CallWindowProc(lpfnSav, hwnd, wm, wParam,
        lParam);
    }


