-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=Begin Listing 13-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
/*****************************************************/
/*  idle.c                                           */
/* -- Communicate with TSR to detect idle interrupt. */
/*****************************************************/

#include <windows.h>
#include "idletsr.h"
#include "idle.h"

BOOL CALLBACK DlgProc(HWND, UINT, WPARAM, LPARAM);

#define wTimerId    1

int FAR PASCAL
WinMain(HINSTANCE hins, HINSTANCE hinsPrev, LPSTR lsz,
  int wShow)
/*****************************************************/
/* -- Entry point.                                   */
/*****************************************************/
    {
    DLGPROC lpfnDlg;
    BYTE    b;

    _asm    mov ax, cmdIsLoaded;
    _asm    int 0x2f;
    _asm    mov b, al;
    if (b != 0xff)
        {
        MessageBox(NULL, "IdleTsr has not been loaded."
          "  Please exit Windows and run idletsr.exe",
          "Idle Checker", MB_OK);
        }
    else if (lpfnDlg = (DLGPROC)MakeProcInstance(
      (FARPROC)DlgProc, hins))
        {
        DialogBox(hins, MAKEINTRESOURCE(dlgIdle),
          NULL, lpfnDlg);
        FreeProcInstance((FARPROC)lpfnDlg);
        return TRUE;
        }

    return FALSE;
    }

BOOL CALLBACK
DlgProc(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lParam)
/*****************************************************/
/* -- Dialog proc.                                   */
/*****************************************************/
    {
    static  BOOL    fPeeking;   /* Reentrancy check. */
    static  BOOL    fPeek;      /* Use PeekMessage? */
    static  BOOL    fSlice;     /* Release slice? */

    switch (wm)
        {
    default:
        return FALSE;

    case WM_INITDIALOG:
        if (!SetTimer(hwnd, wTimerId, 1000, NULL))
            EndDialog(hwnd, FALSE);
        break;

    case WM_TIMER:  /* Get counts from TSR. */
        {
        WORD    w;

        _asm    mov    ax, cmdIdleCheck;
        _asm    int    0x2f;
        _asm    mov w, ax;
        SetDlgItemInt(hwnd, didIdle, w, FALSE);

        _asm    mov    ax, cmdTimerCheck;
        _asm    int    0x2f;
        _asm    mov w, ax;
        SetDlgItemInt(hwnd, didTimer, w, FALSE);
        }
        break;

    case WM_DESTROY:
        KillTimer(hwnd, wTimerId);
        break;

    case WM_COMMAND:
        switch (wParam)
            {
        default:
            return FALSE;

        case IDOK:
        case IDCANCEL:
            fPeek = FALSE;
            EndDialog(hwnd, wParam);
            break;

        case didPeek:   /* Toggle check box. */
            CheckDlgButton(hwnd, didPeek,
              fPeek ^= TRUE);
            break;

        case didSlice:  /* Toggle check box. */
            CheckDlgButton(hwnd, didSlice,
              fSlice ^= TRUE);
            break;
            }
        break;
        }

    if (fPeeking)   /* Prevent reentrant loop. */
        return TRUE;

    /* PeekMessage() loop while checkbox is set. */
    while (fPeeking = fPeek)
        {
        MSG msg;

        if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
            {
            if (msg.message == WM_QUIT)
                {
                fPeek = FALSE;
                EndDialog(hwnd, FALSE);
                }
            else if (!IsDialogMessage(hwnd, &msg))
                {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
                }
            }
        else if (fSlice)
            {
            _asm    mov ax, 0x1680;
            _asm    int 0x28;
            }
        }

    return TRUE;
    }


