/*
 * template.c
 * Written by Moshe Rubin
 */

LPSTR FuncTemplate (LPSTR lpStr, HWND hWnd, int nVar)
{
   HANDLE hMem  = NULL;   /* Memory handle */
   LPSTR  lpMem = NULL;   /* Memory pointer */
   LPSTR  Ret   = NULL;   /* Return value: initialize to "failure" */
 
   /* Validate parameters */
   if (!lpStr)            goto exit;
   if (!IsWindow (hWnd))  goto exit;
   if (!CheckParm (nVar)) goto exit;  /* user-defined validity test */
 
 
   /* An example of memory allocation/locking with error handling*/
   if ((hMem = GlobalAlloc (...)) == NULL)   goto exit;
   if ((lpMem = GlobalLock (hMem)) == NULL)  goto exit;
 
   /* ... */
 
   /* Function successful: set return value to non-failure */
   Ret = lpMem;
 
exit:
   /* Test return value for "failure" */
   if (Ret == NULL)
      {
         /* Error occurred during function -- undo alloc/lock */
         if (lpMem)     GlobalUnlock (hMem);
         if (hMem)      GlobalFree (hMem);
      }
 
   return (Ret);
}
