# Makefile for all programs
# all.mk

!include <ntwin32.mak>

all: win32srv.exe psxagent.exe psxclt.exe rpctime.exe

# This is a WIN32 executable program

win32srv.obj: win32srv.c
    $(cc) $(cflags) $(cvars) win32srv.c
    $(cvtobj) win32srv.obj

win32srv.exe: win32srv.obj
    $(link) $(conflags) -out:win32srv.exe \
    win32srv.obj $(conlibs)

# These are POSIX subsystem executable programs

psxagent.obj: psxagent.c
    $(cc) $(cflags) $(psxvars) $(cvars) psxagent.c
    $(cvtobj) psxagent.obj

rpcclt.obj: rpcclt.c
    $(cc) $(cflags) $(psxvars) $(cvars) rpcclt.c
    $(cvtobj) rpcclt.obj

psxclt.obj: psxclt.c
    $(cc) $(cflags) $(psxvars) $(cvars) psxclt.c
    $(cvtobj) psxclt.obj

rpctime.obj: rpctime.c
    $(cc) $(cflags) $(psxvars) $(cvars) rpctime.c
    $(cvtobj) rpctime.obj

psxagent.exe: psxagent.obj
  $(link) $(psxflags) -out:$*.exe $** $(psxlibs)

psxclt.exe: psxclt.obj rpcclt.obj
  $(link) $(psxflags) -out:$*.exe $** $(psxlibs)

rpctime.exe: rpctime.obj rpcclt.obj
  $(link) $(psxflags) -out:$*.exe $** $(psxlibs)
