/*****************************************************/
/* combokey.c                                        */
/* -- Program to demonstrate interception of         */
/*    keyboard messages for a combo box control.     */
/*****************************************************/

#include <windows.h>
#include <windowsx.h>
#include "combokey.h"

LPARAM  CALLBACK    LFilter(HWND, UINT, WPARAM,
                    LPARAM);
BOOL    CALLBACK    FDlgProc(HWND, UINT, WPARAM,
                    LPARAM);

WNDPROC lpfnCombo;  /* Subclasser's proc. instance. */

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL
WinMain(HINSTANCE hins, HINSTANCE hinsPrev, LPSTR lsz,
  int wShow)
/*****************************************************/
/* -- Entry point.                                   */
/* -- Displays a dialog as the main window.          */
/*****************************************************/
    {
    DLGPROC lpfnDlg;

    if ((lpfnDlg = (DLGPROC)MakeProcInstance(
      (FARPROC)FDlgProc, hins)) != NULL)
        {
        DialogBox(hins, MAKEINTRESOURCE(dlgComboKey),
          NULL, lpfnDlg);
        FreeProcInstance((FARPROC)lpfnDlg);
        return TRUE;
        }

    return FALSE;
    }

BOOL CALLBACK
FDlgProc(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lParam)
/*****************************************************/
/* -- Dialog proc.                                   */
/*****************************************************/
    {
    switch (wm)
        {
    default:
        return FALSE;

    case WM_INITDIALOG:
        {
        WNDPROC lpfn;

        /* Subclass the combo's edit control. */
        if ((lpfn = (WNDPROC)MakeProcInstance(
          (FARPROC)LFilter, GetWindowInstance(hwnd))) != NULL)
            lpfnCombo = SubclassWindow(
              GetWindow(GetDlgItem(hwnd, didCombo),
                GW_CHILD), lpfn);
        }
        break;

    case WM_DESTROY:
        /* Remove the subclasser procedure. */
        FreeProcInstance((FARPROC)SubclassWindow(
          GetWindow(GetDlgItem(hwnd, didCombo),
            GW_CHILD), lpfnCombo));
        return FALSE;

    case WM_KEYDOWN:
    case WM_CHAR:
    case WM_KEYUP:
        /* Pass keyboard messages through  to the */
        /* multi-line edit control. */
        SendDlgItemMessage(hwnd, didText, wm, wParam,
          lParam);
        break;

    case WM_COMMAND:
        if (wParam != IDOK && wParam != IDCANCEL)
            return FALSE;

        EndDialog(hwnd, wParam);
        break;
        }

    return TRUE;
    }

LPARAM CALLBACK
LFilter(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lParam)
/*****************************************************/
/* -- Combo box subclass proc.                       */
/*****************************************************/
    {
    /* Send keyboard messages to the dialog. */
    if (wm == WM_KEYDOWN || wm == WM_CHAR ||
      wm == WM_KEYUP)
        SendMessage(GetParent(GetParent(hwnd)), wm,
          wParam, lParam);

    return CallWindowProc(lpfnCombo, hwnd, wm, wParam,
      lParam);
    }
