;------------------------------------------------------
;   LISTING 1
;
;   sldd.inc
;
;   Structure definitions and segment setup for
;   self-loading MS-DOS device drivers.
;

;Driver command packet .....

RH_HDR  struc
rh_len      db  ?
rh_unit     db  ?
rh_cmd      db  ?
rh_status   dw  ?
rh_resrvd   db  8 dup(?)
rh_nunits   db  ?       ;#block units to be supported
rh_brkofs   dw  ?       ;load address for next
rh_brkseg   dw  ?       ;... driver
rh_bufofs   dw  ?       ;address of table of offsets
rh_bufseg   dw  ?       ;...to BPB tables
rh_drive    db  ?       ;1st free drive# (A=0, B=1)
RH_HDR  ends

;Device driver header block .....
d_header    struc
d_next      dd      ?
d_attr      dw      ?
d_strat     dw      ?
d_intr      dw      ?
d_name      db      8 dup(?)
d_header    ends

; Specialized driver segment setup ......
NOWARN  RES     ;disable reserved-word warnings
                ;for "CONST" and "STACK"

_TEXT   segment byte    public  'CODE'
_TEXT   ends
_DATA   segment word    public  'DATA'
_DATA   ends
CONST   segment word    public  'CONST'
CONST   ends
_BSS    segment word    public  'BSS'
_BSS    ends
STACK   segment para    stack   'STACK'
STACK   ends
_INIT   segment word    public  'INIT'
_INIT   ends

WARN            ;re-enable all warnings

; Establish SMALL model segment group ....
;
DGROUP  group   _DATA,CONST,_BSS,STACK

wptr    equ     <word ptr>
bptr    equ     <byte ptr>
dptr    equ     <dword ptr>
