/*
 * The pause() function, and test driver code 
 * Written by R. Caudill and L. Zolman, 3/93
 */

#include <stdio.h>
#include <conio.h>

void pause(char *msg);
void keyloop(void);

main()
{
    printf("Test routine for pause() function.\n");

    printf("\nAbout to do a simple getch() call. "
            "Try a Function key: ");
    getch();
    
    printf("\n");
    keyloop();

    pause("This is the message to be printed by pause()");
    keyloop();

    return 0;
}

/*
 * Read and echo keystrokes and their hex ASCII values
 */

void keyloop(void)
{
    int c;
    
    printf("\nBeginning key loop. Press Ctrl-C to break out.\n");
    while ((c = getch()) != 0x03)
        printf("Key received: \"%c\" (%02x hex)\n", c, c);
    printf("\nafter loop.\n");
}


/*
 * pause function
 * Written by Ronald R. Caudill
 * Displays the supplied message, then waits
 *  for the user to press a key. Multi-byte key codes
 *  are properly cleared from the keyboard input buffer.
 * 
 */

void pause(char *msg)
{
    puts(msg);
    printf("Hit any key to continue\n");
    if (!getch())
        getch();
}