/*****************************************************/
/* symhook.c                                         */
/* -- Hook functions.                                */
/*****************************************************/

#include <windows.h>
#include <windowsx.h>
#include <toolhelp.h>
#include "symdll.h"
#include "symbase.h"
#define DEFINE_HOOKS
#include "symhook.h"

BOOL WINAPI _export
HookExtTextOut(HDC hdc, int x, int y, UINT eto,
  LPRECT lprect, LPSTR lsz, UINT cb, LPINT lrgdx)
/*****************************************************/
/* -- ExtTextOut() hook function.                    */
/*****************************************************/
    {
    LPCDS    lpcds;
    BOOL    f;
    HFONT    hfntSav    = NULL;

    HookHks(phksExtTextOut, FALSE);
    if ((lpcds = LpcdsGetCur()) != NULL)
        hfntSav = SelectObject(hdc, lpcds->hfnt);
    f = ExtTextOut(hdc, x, y, eto, lprect, lsz, cb,
      lrgdx);
    if (hfntSav != NULL)
        SelectObject(hdc, lpcds->hfnt);
    HookHks(phksExtTextOut, TRUE);
    return f;
    }

DWORD WINAPI _export
HookGetTextExtent(HDC hdc, LPSTR lsz, int cb)
/*****************************************************/
/* -- GetTextExtent() hook function.                 */
/* -- Select the client's font into the DC.          */
/*****************************************************/
    {
    LPCDS    lpcds;
    DWORD   lw;
    HFONT    hfntSav    = NULL;

    HookHks(phksGetTextExtent, FALSE);
    if ((lpcds = LpcdsGetCur()) != NULL)
        hfntSav = SelectObject(hdc, lpcds->hfnt);
    lw = GetTextExtent(hdc, lsz, cb);
    if (hfntSav != NULL)
        SelectObject(hdc, lpcds->hfnt);
    HookHks(phksGetTextExtent, TRUE);
    StopFontMix();
    return lw;
    }
