// wuiobjdb.h - Definitions for WUIman OBJect DataBase.
// Copyright (c) 1993 by Ron Burk

#ifndef WUIOBJDB_H
#define WUIOBJDB_H

#if !(defined(_INC_WINDOWS) || defined(__WINDOWS_H))
    #include <windows.h>
#endif
#include "wuistd.h"
#include "wuiname.h"
#include "wuiargs.h"
#include "wuilist.h"

class   AWuiObject;

// TWuiObjects - a list of type TWuiObject
class   TWuiObjects : public TWuiGenericList
    {
public:
    TWuiObjects(int Size=0);
    void       *Insert(AWuiObject *NewObject, const TWuiName To);
    void       *Insert(AWuiObject *NewObject, int Position=-1);
    AWuiObject *Get(const TWuiName Which);
    AWuiObject *Get(int Position);
    AWuiObject *Remove(const TWuiName Which);
    AWuiObject *Remove(int Position = -1);
    int         NObjects();
private:
    int         Find(const TWuiName Which);
    };

inline
AWuiObject *TWuiObjects::Remove(int Position)
    {   MEMBERASSERT();
    return (AWuiObject *)TWuiGenericList::Remove(Position);
    }
inline
AWuiObject *TWuiObjects::Get(int Position)
    {   MEMBERASSERT();
    return (AWuiObject *)TWuiGenericList::Get(Position);
    }
inline
int     TWuiObjects::NObjects()
    {   MEMBERASSERT();
    return TWuiGenericList::NElements();
    }

class   AWuiObject
    {
public:
    AWuiObject(const TWuiName ObjectName,
                                     const char *Value = 0);
    virtual              ~AWuiObject();
    virtual AWuiObject   *Clone() = 0;
    virtual AWuiObject   *New(const TWuiName Name,
                                     const char *Value) = 0;
    virtual TWuiObjects  *Children();
    virtual TWuiObjects  *Attributes();
    virtual long          Get(const char *Path,
                                             TWuiArgs *Args,
                                      AWuiObject *Attribute,
                            char *Buffer, size_t MaxLength);
    virtual long          Set(const char *Path,
                                             TWuiArgs *Args,
                                      AWuiObject *Attribute,
                                              char *Buffer);
    TWuiName              Name();

    static  AWuiObject   *Root;
private:
    TWuiName              Name_;
    };

inline
TWuiName AWuiObject::Name()
    {   
    return Name_;
    }

class   TWuiRegister
    {
public:
    TWuiRegister(AWuiObject *MasterCopy);
    };


#endif
