// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "sample.h"

#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP 
	// commands
	ON_COMMAND(ID_TOGGLE_INSERT,OnToggleInsert) //JT

	// user-interface message handlers
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_LINE,OnUpdateLine) //JT
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_COL, OnUpdateCol)  //JT
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_TIME,OnUpdateTime) //JT
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_OVR,OnUpdateIns)   //JT
	
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	ID_FILE_NEW,
	ID_FILE_OPEN,
	ID_FILE_SAVE,
		ID_SEPARATOR,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
		ID_SEPARATOR,
	ID_FILE_PRINT,
	ID_APP_ABOUT,
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,			// status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL, 		// end of generated lines
	ID_INDICATOR_OVR,       //JT                         
	ID_INDICATOR_LINE,      //JT
	ID_INDICATOR_COL,       //JT
	ID_INDICATOR_TIME       //JT
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE("Failed to create toolbar\n");
		return -1;		// fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE("Failed to create status bar\n");
		return -1;		// fail to create
	}
	                            
	//JT - All below                            
    // this code will make pane 0 (comment text) inset                                                         
	UINT style,id;
	int width;

	// pane 0
	m_wndStatusBar.GetPaneInfo(0,id,style,width);        
	m_wndStatusBar.SetPaneInfo(0,id,SBPS_STRETCH,width);  // set style to strecthy
	
	// make sure we always have a message, so that OnIdle will update the
	// status bar. If we have no messages, OnIdle will yield to other
	// Windows tasks.
	m_wndStatusBar.SetTimer(1,1000,NULL);

	return 0;
}


// update the time in the status bar.
// This code based on a Microsoft Knowledge base article.
void CMainFrame::OnUpdateTime( CCmdUI* pCmdUI)
{
  CTime curTime =CTime::GetCurrentTime();
  char szTime[9];
  char second[4];
  char prntime[9];
  
  int nHour   = curTime.GetHour();
  int nMinute = curTime.GetMinute();
  int nSecond = curTime.GetSecond();
  
  // give'em a 12 hour clock
  if ( nHour > 12 )
  	nHour = nHour - 12;
  	
  if (nMinute < 10 )
    sprintf(szTime,"%i:0%i", nHour, nMinute);
  else
  	sprintf(szTime, "%i:%i", nHour,nMinute); 
  	
  if (nSecond < 10 )
    sprintf(second,":0%i", nSecond);
  else
    sprintf(second,":%i", nSecond);

  strcat(szTime,second);
  
  sprintf(prntime,"%s",szTime);
    	
  m_wndStatusBar.SetPaneText(7,prntime);   // time is 7th pane
  
  pCmdUI->Enable();	
}
                    
// update the column number in the status bar                    
void CMainFrame::OnUpdateCol( CCmdUI* pCmdUI)
{                                              
   char temp[8];
                                              
   sprintf( temp,"%03d", theApp.GetColNum() );   
   pCmdUI->SetText(temp);     
   pCmdUI->Enable(TRUE);
}

// update the line number in the status bar
void CMainFrame::OnUpdateLine( CCmdUI* pCmdUI)
{  
  char temp[8];
   
   sprintf( temp,"%04d",theApp.GetLineNum() );   
   pCmdUI->SetText(temp);
   pCmdUI->Enable(TRUE);
}

// code to handle insert/overstrike mode

// command to tell the application object to toggle
// the insert state.
void CMainFrame::OnToggleInsert( )
{
  theApp.ToggleIns();
}          

// update the status of the insert/overstrike key
// you could also set the pane's text to OVR or INS depending
// on the flag.
void CMainFrame::OnUpdateIns( CCmdUI* pCmdUI)
{                        
   BOOL bFlag = theApp.GetIns();
   
   pCmdUI->Enable(bFlag);
}

                                 

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
