#include <stdio.h>
#include <string.h>
#include <windows.h>
#include "wuistd.h"
#include "wuiobjdb.h"
#include "wuidbint.h"
#include "wuiman.h"

HINSTANCE   WUIMAN_Instance;

long    WUIMAN_Get(const char *Path, const char *Attribute,
                          char *Result, size_t ResultLength)
    {
    if(AWuiObject::TraceFlag)
        DebugPrintf(">>WUIMAN_Get(Path='%s',Attribute='%s')",
                                           Path, Attribute);
    if(!AWuiObject::Database || !AWuiObject::Root)
        return WUIMAN_ERR_NOT_INITIALIZED;
    char    ModifiablePath[512];
    strcpy(ModifiablePath, Path);
    TWuiArgs    Args(Attribute);
    if(Result)
        *Result = '\0';
    long    Status = AWuiObject::Root->Get(ModifiablePath,
                         &Args, NULL, Result, ResultLength);
    if(AWuiObject::TraceFlag)
        DebugPrintf("<<WUIMAN_Get returns [%ld] \"%s\"",
                            Status, Result?Result:"<NULL>");
    return Status;
    }

long    WUIMAN_Set(const char *Path, const char *Attribute,
                                          const char *Value)
    {
    if(!AWuiObject::Database || !AWuiObject::Root)
        return WUIMAN_ERR_NOT_INITIALIZED;
    char        ModifiablePath[512];
    strcpy(ModifiablePath, Path);
    TWuiArgs    Args(Attribute);
    return AWuiObject::Root->Set(ModifiablePath, &Args, NULL,
                                                     Value);
    }

long    WUIMAN_Init(HINSTANCE Instance, const char *IniFileName)
    {
    WUIMAN_Instance         = Instance;
    TWuiDatabase  *Database = new TWuiDatabase(IniFileName);
    AWuiObject::Database    = Database;
    // if root does not exist, create it
    if(Database->ReadItem("/", ".Version", NULL, 0) == -1)
        Database->WriteItem("/", ".Version",
            "TAttribute,0.0");
    if(Database->ReadItem("/", ".Version", NULL, 0) == -1)
        return WUIMAN_ERR_DATABASE_INIT;
    char    ModifiablePath[512];
    strcpy(ModifiablePath, "/");
    TWuiArgs    Args("m_InitialLoad");
    return AWuiObject::Root->Set(ModifiablePath, &Args, NULL,
                                                     "");
    }

