// wuistd.c - general utility code.
// Copyright (c) 1993 by Ron Burk

#include <string.h>
#include "wuistd.h"
#include <stdarg.h>
#include <stdio.h>
#include <windows.h>

char    *StringClone(const char *Input)
    {
    size_t  Size = strlen(Input)+1;
    char *Result = new char[Size];
    ASSERT(Result != NULL);
    return (char *)memcpy(Result, Input, Size);
    }

HWND    DebugEditControl;
void    InitDebug()
    {
    extern  HINSTANCE WUIMAN_Instance;

    MSG     Message;
    if(!PeekMessage(&Message, NULL, 0, -1, PM_NOREMOVE))
        {
        static  QueueSet = FALSE;
        if(!QueueSet)
            {
            QueueSet    = TRUE;
            SetMessageQueue(120);
            }
        }
    if(DebugEditControl != (HWND)NULL)
        return;
    long    Style   = WS_VISIBLE | WS_OVERLAPPEDWINDOW
                    | WS_HSCROLL | WS_VSCROLL | ES_READONLY
                    | ES_MULTILINE;
    DebugEditControl = CreateWindow("Edit", "",
        Style, CW_USEDEFAULT, CW_USEDEFAULT, 500, 200,
        HWND_DESKTOP, (HMENU)NULL, WUIMAN_Instance, NULL);
    if(DebugEditControl == (HWND)NULL)
        {
        static  Warnings = 0;
        if(Warnings++ < 3)
            MessageBox(NULL,
                    "Could not create WuiMan debugging window.",
                    "WuiMan: DebugPrintf()",
                    MB_OK);
        else if(Warnings++ < 4)
            MessageBox(NULL,
                    "Could not create WuiMan debugging window."
                    "(this is the last time this message will appear).",
                    "WuiMan: DebugPrintf()",
                    MB_OK);
        }
    }


void    DebugPrintf(const char *Format, ...)
    {
    InitDebug();
    char    *Message = "No memory for DebugPrintf().\r\r\n";
    char    *Buffer  = new char[1000];
    if(Buffer)
        {
        va_list Args;
        va_start(Args, Format);
        vsprintf(Buffer, Format, Args);
        va_end(Args);
        Message = Buffer;
        }
    SendMessage(DebugEditControl, EM_REPLACESEL, 0,
                                   (LPARAM)(LPCSTR)Message);
    if(Message[strlen(Message)-1] != '\n')
        SendMessage(DebugEditControl, EM_REPLACESEL, 0,
                                  (LPARAM)(LPCSTR)"\r\r\n");
    if(Buffer)
        delete[] Buffer;
    }
