#include <WINDOWS.H>
#include "epaint.h"
#include "bitmap.h"

#define BLOCK  4

BITMAPINFO *p_binfo;
LOGPALETTE *p_pal;
BYTE _huge *hp_bits;
HDC  h_memDC;
HBITMAP h_bmp;
HPALETTE h_pal;



/**************************************************************************
*  Function Name: bmpCrush
**************************************************************************/
int bmpCrush (HDC hDC, int effect)
{
int x, y;
int left=0, top=0, right=(int)p_binfo->bmiHeader.biWidth-BLOCK,
    bot=(int)p_binfo->bmiHeader.biHeight-BLOCK;

    SetDIBits(h_memDC, h_bmp, 0, (WORD)p_binfo->bmiHeader.biHeight, hp_bits, p_binfo, DIB_PAL_COLORS);

    if (effect == ID_VERTCRUSH) {
        while (top < bot)
        {
            for (x=left;x<=right;x+=BLOCK)
               BitBlt(hDC, x, top, BLOCK, BLOCK, h_memDC, x, top, SRCCOPY);
            top += BLOCK;
            for (x=left;x<=right;x+=BLOCK)
                BitBlt(hDC, x, bot, BLOCK, BLOCK, h_memDC, x, bot, SRCCOPY);
            bot -= BLOCK;
        } //end while (not at center)
    } //End if (vertical crush)

    if (effect == ID_HORZCRUSH) {
        while (left < right)
        {
	        for (y=top;y<=bot;y+=BLOCK)
    	        BitBlt(hDC, right, y, BLOCK, BLOCK, h_memDC, right, y, SRCCOPY);
            right -= BLOCK;
            for (y=top;y<=bot;y+=BLOCK)
    	        BitBlt(hDC, left, y, BLOCK, BLOCK, h_memDC, left, y, SRCCOPY);
            left += BLOCK;
        } //end while (not at center)
    } //End if (horizontal crush)

    return 0;
} //End function (bmpCrush)
/**************************************************************************
*  Function Name: bmpDiagonal
**************************************************************************/
int bmpDiagonal (HDC hDC)
{
int left=0, top=0, right=(int)p_binfo->bmiHeader.biWidth-BLOCK,
    bot=(int)p_binfo->bmiHeader.biHeight-BLOCK;
int startcolumn, startrow, column, row;
DWORD nextTime;

    SetDIBits(h_memDC, h_bmp, 0, (WORD)p_binfo->bmiHeader.biHeight, hp_bits, p_binfo, DIB_PAL_COLORS);

	/* scan diagonals along the top edge*/
	nextTime = GetTickCount() + 10;
	startcolumn = left;
	while (startcolumn <= right) {
		column= startcolumn;
		row= top;
		while (column >= left && row <= bot) {
   	        BitBlt(hDC, column, row, BLOCK, BLOCK, h_memDC, column, row, SRCCOPY);
			column -= BLOCK;
			row += BLOCK;
		} /* end while (more columns in diagonal */
		startcolumn += BLOCK;
        while (GetTickCount() < nextTime);
        nextTime += 10;
	} /* end while (more diagonals to scan along top edge) */

	/* scan diagonals down the right side */
	nextTime = GetTickCount() + 10;
	startrow = top+BLOCK;
	while (startrow <= bot) {
		column = right;
		row = startrow;
		while (column >= left && row <= bot) {
   	        BitBlt(hDC, column, row, BLOCK, BLOCK, h_memDC, column, row, SRCCOPY);
			column -= BLOCK;
			row += BLOCK;
		} /* end while (more columns in diagonal */
		startrow += BLOCK;
        while (GetTickCount() < nextTime);
        nextTime += 10;
	} /* end while (more diagonals to scan along right edge) */

    return 0;
} //End function (bmpDiagonal)


