;------------------------------------------------------
;   LISTING 1
;
;   Filename:           DRVHDR.ASM
;   Summary:            Header for DOS-based,
;                       dynamic-link, driver extension
;                       modules
;   Author:             T.W. Nelson
;   Assembler:          BORLAND
;   Assembly options:
;   Version:            2.00
;   Date:               01-Feb-1993
;   Notes:
;
;   Module must be 1st in link order.  Entry
;   point into the module must be at offset 0
;   in the overlay segment.
;
;   Source code Copyright (c) 1993 T.W. Nelson. May
;   be used only with appropriate acknowledgement of
;   copyright.
;------------------------------------------------------

.model  large,C     ;far code, far data

.stack              ;dummy stack used only for
                    ;marking end of memory
.data

;These data made available to user init function
;to determine module memory size requirements ...
_heapseg    dw  0   ;seg addr, start of heap
_loadseg    dw  0   ;seg addr, start of module

public  C   _heapseg
public  C   _loadseg

;Outlay of driver module function export table .....
expTab struc
funcname    dd  ?   ; ->asciiz name of driver function
pfun        dd  ?   ; -> driver function
expTab ends

;This object required and must be defined
;in the driver extension module ......
extrn   C   fTable:DATAPTR      ;struct expTab[]

.code

;------------------------------------------------------
; int far _hdr_start(struct ModuleDescriptor *mDesc)
;
; NOTE: no code must preceed '_hdr_start' entry point..
;

_hdr_start  proc far uses si di ds, mDesc:dword

;-----  Load local data segment -----------------------
        mov     ax,@data
        mov     ds,ax

;-----  Fill in data for user init --------------------
        mov     ax,seg STACK    ;end of memory (high)
        mov     _heapseg,ax     ;get beg heap
        mov     ax,cs           ;beg memory (low)
        mov     _loadseg,ax     ;== start of overlay

;-----  Call user initialization proc. User init()
;       must be the 1st function listed in the module
;       export table ----------------------------------
        les     bx,mDesc
        mov     di,offset fTable
        mov     dx,seg fTable
        push    es
        push    bx              ;arg for init()
        mov     es,dx
        call    es:[di].pfun    ;init(mDesc *)
        pop     bx              ;fix stack
        pop     es              ;(C calls only) ....
        ret             ;return init() status in ax

_hdr_start  endp

        end

;------ End of File -----------------------------------
