/*****************************************************/
/* launch.c                                          */
/* -- Launch a Windows application.                  */
/* -- To build : cc -DSTRICT launch.c                */
/*****************************************************/
#include <windows.h>
#include "launch.h"

/* ShowWindow() style in numerical order. */
char *    rgszStyle[] =
    {
    "SW_HIDE", "SW_NORMAL", "SW_SHOWMINIMIZED",
    "SW_MAXIMIZE", "SW_SHOWNOACTIVATE", "SW_SHOW",
    "SW_MINIMIZE", "SW_SHOWMINNOACTIVE", "SW_SHOWNA",
    "SW_RESTORE"
    };
#define cszStyle \
  (sizeof rgszStyle / sizeof rgszStyle[0])

/* Maximum command string length. */
#define cchCommandMax 1024

BOOL CALLBACK __export LwDlgProc(HWND hwnd, UINT wm,
  WPARAM wParam, LPARAM lParam);

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hins, HINSTANCE hinsPrev,
                                      LPSTR lpsz, int wShow)
    {
    return DialogBox(hins, MAKEINTRESOURCE(dlgLaunch),
      NULL, LwDlgProc);
    }

BOOL CALLBACK __export
LwDlgProc(HWND hwnd, UINT wm, WPARAM wParam,
  LPARAM lParam)
/*****************************************************/
/* -- Launch dialog procedure.                       */
/*****************************************************/
    {
    switch (wm)
        {
    default:
        break;

    case WM_INITDIALOG:
        {
        int     isz;
        HWND    hwndT;

        /* Fill the style list with style names. */
        hwndT = GetDlgItem(hwnd, didStyle);
        for (isz = 0; isz < cszStyle; isz++)
            SendMessage(hwndT, CB_ADDSTRING, 0,
              (LPARAM)(LPSTR)rgszStyle[isz]);
        SendMessage(hwndT, CB_SETCURSEL, SW_NORMAL, 0);
        }
        return TRUE;

    case WM_COMMAND:
        switch (wParam)
            {
        default:
            break;

        case IDOK:
            {
            char    szBuf[cchCommandMax + 1];

            GetDlgItemText(hwnd, didFileName, szBuf,
              sizeof szBuf);
            WinExec(szBuf, (UINT)SendDlgItemMessage(
              hwnd, didStyle, CB_GETCURSEL, 0, 0));
            }
            return TRUE;

        case IDCANCEL:
            EndDialog(hwnd, 0);
            return TRUE;
            }
        break;
        }
    return FALSE;
    }
