#include <windows.h>
#include <string.h>     // for memcpy()

#include "objthunk.h"

// not everybody supports FP_ macros well
#define SEGMENT(ptr)   ((unsigned short)((unsigned long)(ptr) >> 16))
#define OFFSET(ptr)    ((unsigned short)(unsigned long)(ptr))

// char array avoids structure packing issues
static unsigned char ObjThunk[17] =
    {
    0x58,       // pop    ax
    0x5B,       // pop    bx
    0xB9,       // mov    cx, XXXX
    0x00,       // Segment of this pointer
    0x00,
    0x51,       // push    cx
    0xB9,       // mov    cx, XXXX
    0x00,       // Offset of this pointer
    0x00,
    0x51,       // push    cx
    0x53,       // push    bx
    0x50,       // push    ax
    0xEA,       // jmp    XXXX:XXXX
    0x00, 0x00, 0x00, 0x00
    };

FARPROC Thunkable::MakeThunk(THUNKPROC lpmfnFunc)
{
    char *ot = (char *)GlobalLock(
        GlobalAlloc(GMEM_FIXED|GMEM_SHARE|GMEM_NOT_BANKED,
                                   sizeof(ObjThunk) ) );
    if (ot)
        {
        memcpy(ot, ObjThunk, 17);
        *(int *)(ot+3)      = SEGMENT(this);
        *(int *)(ot+7)      = OFFSET(this);
        *(DWORD *)(ot+13)   = *(DWORD *)&lpmfnFunc;
        PrestoChangoSelector(SEGMENT(ot), SEGMENT(ot));
        }
    return (FARPROC)ot;
}

void Thunkable::FreeThunk(FARPROC lpfnFunc)
{
    if (lpfnFunc)
        {
        PrestoChangoSelector(SEGMENT(lpfnFunc),
                                          SEGMENT(lpfnFunc));
        GlobalFree((HGLOBAL)LOWORD(
                           GlobalHandle(SEGMENT(lpfnFunc))));
        }
}

Thunkable::Thunkable(THUNKPROC Pointer)
    {
    ThunkProcedure  = MakeThunk(Pointer);
    }
Thunkable::~Thunkable()
    {
    FreeThunk(ThunkProcedure);
    }

