///////////////////////////////////////////////////////
// activtrk.c                                        //
// -- DLL monitors changes in the active window      //
//    and notifies client via a registed windows     //
//    message.                                       //
// -- Written by Paul R. Bonneau, 11/26/95.          //
///////////////////////////////////////////////////////
#include <windows.h>
#include "activtrk.h"

#ifdef __WATCOMC__
    #pragma off (unreferenced);
#endif


HWND  hwndClient;
HHOOK hhok;

LRESULT CALLBACK __export LwHookProc(int wCode,
  WPARAM wParam, LPARAM lParam);

typedef struct
    {
    BOOL fMouse;
    HWND hwnd;
    } WAI; // Window Activation Info.

#ifdef __BORLANDC__
#pragma argsused
#endif //__BORLANDC__
int CALLBACK LibMain(HINSTANCE hins, WORD ds,
  WORD cbHeap, LPSTR lsz)
///////////////////////////////////////////////////////
// -- Library entry procedure.  Install the CBT      //
//    hook.                                          //
///////////////////////////////////////////////////////
    {
    return NULL == (hhok = SetWindowsHookEx(WH_CBT,
      (HOOKPROC)LwHookProc, hins, NULL)) ? 0 : 1;
    }

#ifdef __BORLANDC__
    #pragma argsused
#endif
int CALLBACK __export WEP(int wExit)
///////////////////////////////////////////////////////
// -- Remove CBT hook.                               //
///////////////////////////////////////////////////////
    {
    if (NULL != hhok)
        {
        UnhookWindowsHookEx(hhok);
        hhok = NULL;
        }

    return 1;
    }

BOOL CALLBACK __export FRegisterWnd(HWND hwnd)
///////////////////////////////////////////////////////
// -- Install the client's notification window.      //
// -- hwnd : Window to receive notifications.        //
///////////////////////////////////////////////////////
    {
    if (NULL != hwndClient)
        return FALSE;

    hwndClient = hwnd;
    return TRUE;
    }

void CALLBACK __export UnregisterWnd(HWND hwnd)
///////////////////////////////////////////////////////
// -- Remove the client's notification window.       //
///////////////////////////////////////////////////////
    {
    if (hwnd == hwndClient)
        hwndClient = NULL;
    }

#ifdef __BORLANDC__
    #pragma argsused
#endif
LRESULT CALLBACK __export LwHookProc(int wCode,
  WPARAM wParam, LPARAM lParam)
///////////////////////////////////////////////////////
// -- CBT hook callback.                             //
///////////////////////////////////////////////////////
    {
    if (HCBT_ACTIVATE == wCode && IsWindow(hwndClient))
        SendMessage(hwndClient, wmActive, wParam,
          MAKELONG(((WAI FAR *)lParam)->hwnd, 0));

    CallNextHookEx(hhok, wCode, wParam, lParam);
    return 0;
    }
