/*
	File: Dialog1.Cpp
	Author: Raja
	Date: 13/05/1995.

	Dialog class, uses CDialog as base class. WM_CTLCOLOR message handler
	never gets called !
*/

#include "stdafx.h"
#include "generic.h"
#include "dialog1.h"

#define TEXT_COLOR 					(RGB (255, 0, 0))			// Red.
#define BACKGROUND_COLOR 			(RGB (255, 255, 0))		// Yellow.

CDialog1::CDialog1(CWnd* pParent /*=NULL*/)
	: CDialog(CDialog1::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialog1)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CDialog1::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialog1)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDialog1, CDialog)
	//{{AFX_MSG_MAP(CDialog1)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************************/
// Raja 13/05/1995.
// OnCtlColor - WM_CTLCOLOR message handler.
// If for the edit field, set the text and background color, otherwise call
// base class version.
/****************************************************************************/

HBRUSH CDialog1::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	if ((nCtlColor == CTLCOLOR_EDIT) || (nCtlColor == CTLCOLOR_MSGBOX)) {
		pDC->SetBkColor (BACKGROUND_COLOR);
		pDC->SetTextColor (TEXT_COLOR);
		pDC->SetBkMode (TRANSPARENT);
		return m_hBrush;
	}
	else
		return CDialog::OnCtlColor (pDC, pWnd, nCtlColor);
}

/****************************************************************************/
// Raja 13/05/1995.
// OnInitDialog - MFC Virtual function handler for WM_INITDIALOG
// Create a brush to be used for background painting.
/****************************************************************************/

BOOL CDialog1::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_hBrush = ::CreateSolidBrush (BACKGROUND_COLOR);
	if (m_hBrush == NULL)
		TRACE0 ("m_hBrush creation failed.\n");
	return TRUE;
}

/****************************************************************************/
// Raja 13/05/1995.
// OnCancel - MFC Virtual function handler for WM_COMMAND - IDCANCEL.
// Delete the brush, call base class version.
/****************************************************************************/

void CDialog1::OnCancel()
{
	if (m_hBrush)
		DeleteObject (m_hBrush);
	CDialog::OnCancel();
}

/****************************************************************************/
// Raja 13/05/1995.
// OnOK - MFC Virtual function handler for WM_COMMAND - IDOK.
// Delete the brush, call base class version.
/****************************************************************************/

void CDialog1::OnOK()
{
	if (m_hBrush)
		DeleteObject (m_hBrush);
	CDialog::OnOK();
}

