/*
	File: Dialog2.Cpp
	Author: Raja
	Date: 13/05/1995.

	Dialog class, uses ZDialog as base class. WM_CTLCOLOR message handler
	gets called as expected.
*/

#include "stdafx.h"
#include "generic.h"
#include "dialog2.h"

#define TEXT_COLOR 					(RGB (255, 0, 0))			// Red.
#define BACKGROUND_COLOR 			(RGB (255, 255, 0))		// Yellow.

/////////////////////////////////////////////////////////////////////////////
// CDialog2 dialog

CDialog2::CDialog2(CWnd* pParent /*=NULL*/)
	: ZDialog(CDialog2::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDialog2)
	//}}AFX_DATA_INIT
}

void CDialog2::DoDataExchange(CDataExchange* pDX)
{
	ZDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDialog2)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDialog2, ZDialog)
	//{{AFX_MSG_MAP(CDialog2)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/****************************************************************************/
// Raja 13/05/1995.
// OnCtlColor - WM_CTLCOLOR message handler.
// If for the edit field, set the text and background color, otherwise call
// base class version.
/****************************************************************************/

HBRUSH CDialog2::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	if ((nCtlColor == CTLCOLOR_EDIT) || (nCtlColor == CTLCOLOR_MSGBOX)) {
		pDC->SetBkColor (BACKGROUND_COLOR);
		pDC->SetTextColor (TEXT_COLOR);
		pDC->SetBkMode (TRANSPARENT);
		return m_hBrush;
	}
	else
		return ZDialog::OnCtlColor (pDC, pWnd, nCtlColor);
}

/****************************************************************************/
// Raja 13/05/1995.
// OnInitDialog - MFC Virtual function handler for WM_INITDIALOG
// Create a brush to be used for background painting.
/****************************************************************************/

BOOL CDialog2::OnInitDialog()
{
	ZDialog::OnInitDialog();
	m_hBrush = ::CreateSolidBrush (BACKGROUND_COLOR);
	if (m_hBrush == NULL)
		TRACE0 ("m_hBrush creation failed.\n");
	return TRUE;
}

/****************************************************************************/
// Raja 13/05/1995.
// OnCancel - MFC Virtual function handler for WM_COMMAND - IDCANCEL.
// Delete the brush, call base class version.
/****************************************************************************/

void CDialog2::OnCancel()
{
	if (m_hBrush)
		DeleteObject (m_hBrush);
	ZDialog::OnCancel();
}

/****************************************************************************/
// Raja 13/05/1995.
// OnOK - MFC Virtual function handler for WM_COMMAND - IDOK.
// Delete the brush, call base class version.
/****************************************************************************/

void CDialog2::OnOK()
{
	if (m_hBrush)
		DeleteObject (m_hBrush);
	ZDialog::OnOK();
}

