// ****************************************************************************
// File:    dbbmprec.h
//
// Date:    October 22, 1994
//
// Author:  Greg Johnson
//
// Compiler:    Microsoft Visual C++ version 1.5, Microsoft Foundation Class
//              Library (MFC), version 2.5
//
// Purpose: This file declares the dbBmpRecordset class, which is used as an
//          interface to the Bitmaps database table for storing and retrieving
//          Windows bitmaps and an associated identifier and description.
//
//          The dbBmpRecordset class is derived from the CRecordset MFC class
//          for specifics to the Bitmaps table in the BMP.MDB database, which
//          is a Microsoft Access version 1.1 format.
// 
// ****************************************************************************

#ifndef _DbBmpRec_
#define _DbBmpRec_

class dbBitmap;

/////////////////////////////////////////////////////////////////////////////
// dbBmpRecordset recordset

class dbBmpRecordset : public CRecordset
{
    public:
        dbBmpRecordset(CDatabase* pDatabase);
        virtual ~dbBmpRecordset(void);
        
        BOOL qryBitmap(dbBitmap*);              // retrieve bitmap from binary field
        BOOL setBitmap(dbBitmap*);              // store bitmap inot binary field
        
        int& qryID(void)                        // returns bitmap Identifier (key field)
            { return(m_ID); }
            
        CString& qryDescr(void)                 // returns the description field
            { return(m_Descr); }
            
    // Implementation
    protected:
        // Field/Param Data
        //{{AFX_FIELD(dbBmpRecordset, CRecordset)
        int     m_ID;
        CString m_Descr;
        CLongBinary m_Bmp;
        //}}AFX_FIELD

        virtual CString GetDefaultConnect();    // Default connection string
        virtual CString GetDefaultSQL();    // Default SQL for Recordset
        virtual void DoFieldExchange(CFieldExchange* pFX);  // RFX support
        DECLARE_DYNAMIC(dbBmpRecordset)
};


#endif  // _DbBmpRec_



