/* @(#) DirEnt.h 1995-06-13 - directory types, etc.
 * Copyright (c) 1995 by JR (John Rogers).
 *
 * AUTHOR - JR (John Rogers, 72634.2402@CompuServe.com)
 */

#ifndef DIRENT_H
#define DIRENT_H

#include <stddef.h>     /* size_t. */

struct dirent {  /* DO NOT do sizeof(struct dirent). */

   size_t  d_namlen;  /* Len of d_name, not including
                       * the trailing null char. */

   /*
    * d_name is the only field guaranteed by POSIX.1.
    * Note that the size may vary, and that this is
    * a null-terminated string
    */
   char d_name[1];
};

/* Actual contents internal to impl. */
typedef struct tagDIR DIR;

int             closedir(DIR *  Dir_Pointer);
DIR *           opendir(const char *  Dir_Name);
struct dirent * readdir(DIR *  Dir_Pointer);
void            rewinddir(DIR *  Dir_Pointer);

#endif
