/*
    File: ZPinup.h
    Author: V.Ramachandran
    Date: September 08, 1995

    ZPinupDialog: Toggles between modal and modeless states.
*/

#ifndef __ZPINUPDIALOG__
#define __ZPINUPDIALOG__

class ZPinupDialog : public CDialog
{
// Construction
public:
    ZPinupDialog (UINT nID, CWnd *pParent = NULL);
    ZPinupDialog (LPCSTR lpszTemplateName, 
                        CWnd *pParent = NULL);

// Interface functions
public:
    void SetPinupState (BOOL bPinup);
    BOOL GetPinupState () { return m_bPinup; }
    BOOL DisplayDialog (BOOL bPinup = FALSE);

// Overrideable.
protected:
    virtual BOOL DoClickProcessing ();

// Implementation
protected:
    //{{AFX_MSG(ZPinupDialog)
    afx_msg void OnDestroy();
    afx_msg void OnSysCommand (UINT nID, LPARAM lParam);
    //}}AFX_MSG
    virtual void OnOK ();
    virtual void OnCancel ();
    BOOL IsPtInDialog (POINT pt);

    BOOL Create (LPCSTR lpszTemplate, CWnd *pParent = NULL);

    DECLARE_MESSAGE_MAP()
    DECLARE_DYNAMIC (ZPinupDialog)

protected:
    BYTE m_bPinup;
    static HHOOK m_hOldHook;
    static int m_nNofDialogs;

private:
    static LRESULT CALLBACK MouseFunc (int nCode, 
                        WPARAM wParam, LPARAM lParam);
};

#endif //__ZPINUPDIALOG__
