// mvwsdi.cpp : implementation file
//

#include "issstd.h"
#include "multivie.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

///////////////////////////////////////////////////////////
// CSDIMultiViewWnd

IMPLEMENT_DYNCREATE(CSDIMultiViewWnd, CFrameWnd)

CSDIMultiViewWnd::CSDIMultiViewWnd()
{
    nViewId = AFX_IDW_PANE_FIRST ;
}

CSDIMultiViewWnd::~CSDIMultiViewWnd()
{
}

BOOL CSDIMultiViewWnd::OnCreateClient(LPCREATESTRUCT,
                            CCreateContext* pContext)
{
    // default create client will create a view if
    // asked for it
    if (pContext != NULL)
    {
        // try to create view object from RuntimeClass
        if (pContext->m_pNewViewClass != NULL)
        {
            CWnd* pView = (CWnd*)pContext->
                           m_pNewViewClass->CreateObject();
                // NOTE: can be a CWnd with
                // PostNcDestroy self cleanup

            if (pView == NULL)
            {
                TRACE1("Warning: Dynamic create of view "
                       "type %Fs failed\n",
                       pContext->
                         m_pNewViewClass->m_lpszClassName);
                return FALSE;
            }
            ASSERT(pView->IsKindOf(RUNTIME_CLASS(CWnd)));
            // Views are always created with a border !

            if (!pView->Create(NULL, NULL,
                               AFX_WS_DEFAULT_VIEW |
                                    WS_CLIPSIBLINGS,
                               CRect(0,0,0,0),
                               this,
                               nViewId,
                               pContext))
            {
                TRACE0("Warning: couldn't create view "
                       "for frame\n");
                return FALSE; // can't go without a view
            }

            // WS_CLIPSIBLINGS must be on -
            // some Create functions do not
            // use the requested style (i.e. CFormView)
            DWORD dwStyle = pView->GetStyle();
            if (!(dwStyle & WS_CLIPSIBLINGS))
            {
                TRACE1("Warning: Setting WS_CLIPSIBLINGS "
                       "for view %Fs\n",
                       pContext->
                       m_pNewViewClass->m_lpszClassName);
                // toggle WS_CLIPSIBLINGS
                ::SetWindowLong(pView->GetSafeHwnd(),
                                GWL_STYLE,
                                dwStyle ^ WS_CLIPSIBLINGS);
            }

            nViewId++ ;

            return (BOOL)pView ;

        }
    }

    return TRUE;

}


void CSDIMultiViewWnd::SetActiveView(CView *pViewNew,
                                     BOOL bNotify)
{
    CWnd    *pViewOld ;
    
    int nViewNewId = pViewNew->GetDlgCtrlID() ;
    pViewOld = GetDescendantWindow(AFX_IDW_PANE_FIRST) ;
    
    if (nViewNewId != AFX_IDW_PANE_FIRST) {
        ::SetWindowWord(pViewOld->m_hWnd,
                        GWW_ID, (WORD)nViewNewId) ;
        ::SetWindowWord(pViewNew->m_hWnd,
                        GWW_ID, AFX_IDW_PANE_FIRST) ;
    
        pViewOld->ShowWindow(SW_HIDE);
        CFrameWnd::SetActiveView(pViewNew, bNotify) ;
        RecalcLayout() ;
        pViewNew->ShowWindow(SW_SHOW) ;
        pViewNew->BringWindowToTop() ;
    }

}

BEGIN_MESSAGE_MAP(CSDIMultiViewWnd, CFrameWnd)
    //{{AFX_MSG_MAP(CSDIMultiViewWnd)
        // NOTE - the ClassWizard will add and remove mapping macros here.
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSDIMultiViewWnd message handlers

