// WDJExecCtl.cpp : Implementation of the CWDJExecCtrl OLE control class.

#include "stdafx.h"
#include "WDJ.h"
#include "WDJExecCtl.h"
#include "WDJExecPpg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CWDJExecCtrl, COleControl)

/////////////////////////////////////////////////////////////////////////////
// Message map
static const UINT nCompletedMessage = RegisterWindowMessage("WDJ Completed");

BEGIN_MESSAGE_MAP(CWDJExecCtrl, COleControl)
	//{{AFX_MSG_MAP(CWDJExecCtrl)
	// NOTE - ClassWizard will add and remove message map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
	ON_REGISTERED_MESSAGE(nCompletedMessage, CompletedMsgHandler)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CWDJExecCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CWDJExecCtrl)
	DISP_PROPERTY_NOTIFY(CWDJExecCtrl, "AppPath", m_strAppPath, OnAppPathChanged, VT_BSTR)
	DISP_PROPERTY_NOTIFY(CWDJExecCtrl, "Arguments", m_strArguments, OnArgumentsChanged, VT_BSTR)
	DISP_PROPERTY_NOTIFY(CWDJExecCtrl, "StartupPath", m_strStartupPath, OnStartupPathChanged, VT_BSTR)
	DISP_PROPERTY_NOTIFY(CWDJExecCtrl, "Wait", m_bWait, OnWaitChanged, VT_BOOL)
	DISP_PROPERTY_NOTIFY(CWDJExecCtrl, "ShowWindow", m_iShowWindow, OnShowWindowChanged, VT_I2)
	DISP_FUNCTION(CWDJExecCtrl, "Execute", Execute, VT_I4, VTS_NONE)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CWDJExecCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()

/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CWDJExecCtrl, COleControl)
	//{{AFX_EVENT_MAP(CWDJExecCtrl)
	EVENT_CUSTOM("Completed", FireCompleted, VTS_I4  VTS_BOOL)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()

/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CWDJExecCtrl, 1)
	PROPPAGEID(CWDJExecPropPage::guid)
END_PROPPAGEIDS(CWDJExecCtrl)

/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CWDJExecCtrl, "WDJ.WDJExecCtrl.1",
	0x753e0ee3, 0x38ae, 0x11cf, 0xb6, 0x29, 0x44, 0x45, 0x53, 0x54, 0, 0)

/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CWDJExecCtrl, _tlid, _wVerMajor, _wVerMinor)

/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DWDJExec =
		{ 0x753e0ee1, 0x38ae, 0x11cf, { 0xb6, 0x29, 0x44, 0x45, 0x53, 0x54, 0, 0 } };
const IID BASED_CODE IID_DWDJExecEvents =
		{ 0x753e0ee2, 0x38ae, 0x11cf, { 0xb6, 0x29, 0x44, 0x45, 0x53, 0x54, 0, 0 } };

/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwWDJExecOleMisc =
	OLEMISC_SIMPLEFRAME |
	OLEMISC_INVISIBLEATRUNTIME |
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CWDJExecCtrl, IDS_WDJEXEC, _dwWDJExecOleMisc)

/////////////////////////////////////////////////////////////////////////////
// CWDJExecCtrl::CWDJExecCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CWDJExecCtrl

BOOL CWDJExecCtrl::CWDJExecCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_WDJEXEC,
			IDB_WDJEXEC,
			FALSE,                      //  Not insertable
			_dwWDJExecOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CWDJExecCtrl::CWDJExecCtrl - Constructor

CWDJExecCtrl::CWDJExecCtrl()
{
	InitializeIIDs(&IID_DWDJExec, &IID_DWDJExecEvents);
	EnableSimpleFrame();
	
	// Idle event starts out in the signaled state
	m_hEventReady = CreateEvent(NULL, TRUE, TRUE, NULL);

	SetInitialSize(32,32);
	
	// Our "handle" is set to zero. Only >0 will ever be allocated.
	m_lCount = 0;  
}


/////////////////////////////////////////////////////////////////////////////
// CWDJExecCtrl::~CWDJExecCtrl - Destructor

CWDJExecCtrl::~CWDJExecCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CWDJExecCtrl::OnDraw - Drawing function

void CWDJExecCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	CBitmap bitmap;
	BITMAP bmp;
	CRect rcSrcBounds;
	CPictureHolder pic;

	// Load Bitmap from the resource file.
	bitmap.LoadBitmap(IDB_CTRLEXEC);
	bitmap.GetObject(sizeof(BITMAP), &bmp);
	rcSrcBounds.right = bmp.bmWidth;
	rcSrcBounds.bottom = bmp.bmHeight;

	// Create the picture and display it...
	pic.CreateFromBitmap ((HBITMAP) bitmap.m_hObject, NULL, FALSE);
	pic.Render(pdc, rcBounds, rcSrcBounds);
}


/////////////////////////////////////////////////////////////////////////////
// CWDJExecCtrl::DoPropExchange - Persistence support

void CWDJExecCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// Call PX_ functions for each persistent custom property.
	PX_String(pPX, _T("AppPath"), m_strAppPath, _T(""));
	PX_String(pPX, _T("Arguments"), m_strArguments, _T(""));
	PX_String(pPX, _T("StartupPath"), m_strStartupPath, _T(""));
	PX_Bool(pPX, _T("Wait"), m_bWait, FALSE);
	PX_Short(pPX, _T("ShowWindow"), m_iShowWindow, 1); // Show normal window
}


/////////////////////////////////////////////////////////////////////////////
// CWDJExecCtrl::OnResetState - Reset control to default state

void CWDJExecCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange
	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CWDJExecCtrl::AboutBox - Display an "About" box to the user

void CWDJExecCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_WDJEXEC);
	dlgAbout.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// Shell Process Worker Thread.
UINT CWDJExecCtrl::ShellThread(LPVOID pParam)
{
    CWDJExecCtrl *pObject = (CWDJExecCtrl *) pParam;
	
    if (pObject == NULL ||
        !pObject->IsKindOf(RUNTIME_CLASS(CWDJExecCtrl)))
		return 1;	// Thread fails: illegal parameter

	CString strCommandLine;
	LPTSTR lpStartupPath = NULL;
	long lExecID = pObject->m_lCount;

	SetEvent(pObject->m_hEventReady);

	// Cat the command line and the arguments into a single string.
	strCommandLine = pObject->m_strAppPath;
	if (!pObject->m_strArguments.IsEmpty())
		strCommandLine += " " + pObject->m_strArguments;
	
	// Send the starting directory or NULL if it's empty.
	if (!pObject->m_strStartupPath.IsEmpty())
		  lpStartupPath = pObject->m_strStartupPath.GetBuffer(1);

	STARTUPINFO si = {0};
	PROCESS_INFORMATION pi = {0};

	si.cb = sizeof(STARTUPINFO);
	si.lpReserved = NULL;
	si.lpReserved2 = NULL;
	si.cbReserved2 = 0;
	si.lpDesktop = NULL;
	si.dwFlags = STARTF_USESHOWWINDOW;	 // this enables wShowWindow
	si.wShowWindow = pObject->m_iShowWindow;

	if (CreateProcess( NULL,
	     strCommandLine.GetBuffer(1),
	     NULL,
	     NULL,
	     TRUE,
	     NORMAL_PRIORITY_CLASS,
	     NULL,
	     lpStartupPath,
	     &si,
	     &pi ))
	{
		WaitForSingleObject(pi.hProcess, INFINITE);
		CloseHandle(pi.hProcess);
		CloseHandle(pi.hThread);
		pObject->PostMessage(nCompletedMessage, TRUE, lExecID);
	    return 0;  // Thread Success!
	}
	else
	{
		pObject->PostMessage(nCompletedMessage, FALSE, 0);
		return 1; // Thread Failed.
	}
}

/////////////////////////////////////////////////////////////////////////////
// CWDJExecCtrl message handlers
void CWDJExecCtrl::OnAppPathChanged() 
{
	SetModifiedFlag();
}

void CWDJExecCtrl::OnArgumentsChanged() 
{
	SetModifiedFlag();
}

void CWDJExecCtrl::OnStartupPathChanged() 
{
	SetModifiedFlag();
}

void CWDJExecCtrl::OnWaitChanged() 
{
	SetModifiedFlag();
}

void CWDJExecCtrl::OnShowWindowChanged() 
{
	SetModifiedFlag();
}

LONG CWDJExecCtrl::CompletedMsgHandler(UINT wParam, LONG lParam)
{
	if (!m_bWait)
		FireCompleted(lParam, wParam);
	return 1;	
}

// Returns 0 if fails or non-zero (Handle) if successful thread.
long CWDJExecCtrl::Execute() 
{
	// Wait for any threads to startup.
	WaitForSingleObject(m_hEventReady, INFINITE);

	m_lCount++; // Make a new "handle".

	if (m_bWait)
	{
		// We're waiting, so just call the ShellThread method directly.
		if (ShellThread(this) == 1)
			return 0;
	}
	else
	{
		// Not waiting, so create a new thread and get it started.
		AfxBeginThread(ShellThread, this);
	}
	return m_lCount;  // Return the "handle"
}
