// generdlg.cpp : implementation file
// OnInitDialog adds the items. RClickListView switches the views.
// AddItemToListView is a helper function which adds strings to the
// listview control.

#include "stdafx.h"
#include "generic.h"
#include "generdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGenericDlg dialog

CGenericDlg::CGenericDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CGenericDlg::IDD, pParent), m_pilBig (NULL), 
      m_pilSmall (NULL)
{
    //{{AFX_DATA_INIT(CGenericDlg)
    //}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CGenericDlg::~CGenericDlg ()
{
    delete m_pilBig;
    delete m_pilSmall;
}

void CGenericDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CGenericDlg)
    DDX_Control(pDX, IDC_LISTVIEW, m_lvList);
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGenericDlg, CDialog)
    //{{AFX_MSG_MAP(CGenericDlg)
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_NOTIFY(NM_RCLICK, IDC_LISTVIEW, OnRclickListview)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGenericDlg message handlers

#define GROW_BY_VALUE 1

BOOL CGenericDlg::OnInitDialog()
{
    CDialog::OnInitDialog();
    CenterWindow();

    m_lvList.EnableDragDrop (); // Enable drag-drop.

// Set image lists for listview. For test purposes, we will use the
// standard MFC toolbar bitmap itself.

    m_pilBig = new CImageList;
    m_pilSmall = new CImageList;
    if ((!m_pilBig) || (!m_pilSmall)) {
        TRACE0 ("New failed in InitDialog.\n");
        ASSERT (FALSE);
        return TRUE;
    }

// Create the image lists.
    BOOL bRet = m_pilBig->Create (IDR_MAINFRAME, 16, GROW_BY_VALUE,
                    RGB (192, 192, 192));
    if (!bRet)
        return TRUE;
    bRet = m_pilSmall->Create (IDR_MAINFRAME, 16, GROW_BY_VALUE, 
                    RGB (192, 192, 192));
    if (!bRet)
        return TRUE;

// Assign the image lists to the listview control.  
    m_lvList.SetImageList (m_pilBig, LVSIL_NORMAL);
    m_lvList.SetImageList (m_pilSmall, LVSIL_SMALL);

// Create a single row for Report view.
    LV_COLUMN lvC;
    lvC.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
    lvC.fmt = 0;
    lvC.cx = 150;
    lvC.pszText = "Name";
    m_lvList.InsertColumn (0, &lvC);


// Add the items now. Calls a member function to do the adding.
    VERIFY (-1 != AddItemToListView (1, "Raja"));
    VERIFY (-1 != AddItemToListView (2, "Milind Sabne"));
    VERIFY (-1 != AddItemToListView (3, "Satish Bhat"));
    VERIFY (-1 != AddItemToListView (4, "Murtaza Nagarwala"));
    VERIFY (-1 != AddItemToListView (5, "Vineet Bahal"));
    VERIFY (-1 != AddItemToListView (6, "Venkat Iyer"));
    VERIFY (-1 != AddItemToListView (7, "Anish Vaidya"));
    VERIFY (-1 != AddItemToListView (8, "Vivek"));
    VERIFY (-1 != AddItemToListView (0, "Usha Munshi"));
    VERIFY (-1 != AddItemToListView (1, "R.D.Deshpande"));

    return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGenericDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGenericDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

// Switch view on rclick. Since the views are #defined 0 to 3, use
// mod 4 to keep switching views.

void CGenericDlg::OnRclickListview(NMHDR* pNMHDR, LRESULT* pResult) 
{
    static int nView = 0;
    DWORD dwStyle = GetWindowLong (m_lvList.m_hWnd, GWL_STYLE);
    SetWindowLong (m_lvList.m_hWnd, GWL_STYLE, 
                (dwStyle & ~LVS_TYPEMASK) | (nView++ % 4));
    *pResult = 0;
}

/*********************************************************************/
// AddItemToListView - internal function.
// Adds an item to the end (if no sort is specified).
// Parameter: Icon id, string.
// Returns: Item number or -1 on failure.
/*********************************************************************/

int CGenericDlg::AddItemToListView (int iImage, LPTSTR szBuffer)
{
    ASSERT (::IsWindow (m_hWnd));       // Create called ?

    LV_ITEM lvI;
    lvI.mask = LVIF_TEXT | LVIF_IMAGE | LVIF_STATE;
    lvI.state = 0;
    lvI.stateMask = 0;

// Get the current count, so we can add to the end.
    lvI.iItem = m_lvList.GetItemCount ();   
    lvI.iSubItem = 0;
    lvI.pszText = szBuffer;
    lvI.cchTextMax = 0;     // Ignored when setting attributes.
    lvI.iImage = iImage;
    lvI.lParam = 0;

    return m_lvList.InsertItem (&lvI);  // Insert item.
}

