// DIB Section TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DIB Section Test.h"
#include "DIB Section TestDlg.h"
#include "DIB Section.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDIBSectionTestDlg dialog

CDIBSectionTestDlg::CDIBSectionTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDIBSectionTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDIBSectionTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDIBSectionTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDIBSectionTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDIBSectionTestDlg, CDialog)
	//{{AFX_MSG_MAP(CDIBSectionTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_FILE_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_ALL, OnAllColors)
	ON_BN_CLICKED(IDC_BLUE, OnBlue)
	ON_BN_CLICKED(IDC_GREEN, OnGreen)
	ON_BN_CLICKED(IDC_RED, OnRed)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDIBSectionTestDlg message handlers

BOOL CDIBSectionTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_Bitmap.Load(AfxGetResourceHandle(), MAKEINTRESOURCE(IDB_DEFAULT));
	
	ASSERT(m_Bitmap.GetBits() != NULL);
	
	SendDlgItemMessage(IDC_ALL, BM_SETCHECK, BST_CHECKED);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDIBSectionTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();

		RedrawBitmap();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDIBSectionTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDIBSectionTestDlg::OnOpen() 
{
	CFileDialog FileDialog(TRUE,
								  _T("bmp"),
								  _T("*.bmp"),
								  OFN_HIDEREADONLY | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST,
								  _T("Bitmap Files | *.bmp | All Files | *.* ||"),
								  this);

	if ( FileDialog.DoModal() == IDOK )
	{
		CString str = FileDialog.GetPathName();
		
		if ( !m_Bitmap.Load(str) )
			MessageBox("Unable to load file.", "Error", MB_OK | MB_ICONEXCLAMATION);

		RedrawWindow();
		SendDlgItemMessage(IDC_ALL, BM_SETCHECK, BST_CHECKED);
		SendDlgItemMessage(IDC_RED, BM_SETCHECK, BST_UNCHECKED);
		SendDlgItemMessage(IDC_GREEN, BM_SETCHECK, BST_UNCHECKED);
		SendDlgItemMessage(IDC_BLUE, BM_SETCHECK, BST_UNCHECKED);
	}
}

void CDIBSectionTestDlg::OnAllColors() 
{
	m_Bitmap.ResetPalette();
	RedrawBitmap();
}

void CDIBSectionTestDlg::OnBlue() 
{
	m_Bitmap.ResetPalette();
	
	CPalette* pPalette = m_Bitmap.GetPalette();

	if (pPalette == NULL)
		return;
	
	int nNumColors = pPalette->GetEntryCount();
	PPALETTEENTRY pPalEntry = new PALETTEENTRY[nNumColors];

	if (pPalEntry == NULL)
		return;

	pPalette->GetPaletteEntries(0, nNumColors, pPalEntry);
	
	for (int i = 0; i < nNumColors; i++)
	{
		pPalEntry[i].peRed	= 0;
		pPalEntry[i].peGreen = 0;
	}

	pPalette->SetPaletteEntries(0, nNumColors, pPalEntry);

	delete [] pPalEntry;
	
	m_Bitmap.SetPalette(*pPalette);
	
	RedrawBitmap();
}

void CDIBSectionTestDlg::OnGreen() 
{
	m_Bitmap.ResetPalette();
	
	CPalette* pPalette = m_Bitmap.GetPalette();

	if (pPalette == NULL)
		return;
	
	int nNumColors = pPalette->GetEntryCount();
	PPALETTEENTRY pPalEntry = new PALETTEENTRY[nNumColors];

	if (pPalEntry == NULL)
		return;

	pPalette->GetPaletteEntries(0, nNumColors, pPalEntry);
	
	for (int i = 0; i < nNumColors; i++)
	{
		pPalEntry[i].peRed	= 0;
		pPalEntry[i].peBlue  = 0;
	}

	pPalette->SetPaletteEntries(0, nNumColors, pPalEntry);

	delete [] pPalEntry;
	
	m_Bitmap.SetPalette(*pPalette);
	
	RedrawBitmap();
}

void CDIBSectionTestDlg::OnRed() 
{
	m_Bitmap.ResetPalette();
	
	CPalette* pPalette = m_Bitmap.GetPalette();

	if (pPalette == NULL)
		return;
	
	int nNumColors = pPalette->GetEntryCount();
	PPALETTEENTRY pPalEntry = new PALETTEENTRY[nNumColors];

	if (pPalEntry == NULL)
		return;

	pPalette->GetPaletteEntries(0, nNumColors, pPalEntry);
	
	for (int i = 0; i < nNumColors; i++)
	{
		pPalEntry[i].peGreen = 0;
		pPalEntry[i].peBlue = 0;
	}

	pPalette->SetPaletteEntries(0, nNumColors, pPalEntry);

	delete [] pPalEntry;
	
	m_Bitmap.SetPalette(*pPalette);
	
	RedrawBitmap();
}

void CDIBSectionTestDlg::RedrawBitmap()
{
	CClientDC dc(this);
	CRect rcClient;
		
	GetClientRect(&rcClient);
	rcClient.OffsetRect(10, 10);
	m_Bitmap.Draw(&dc, rcClient);
}
