// DIB Section.h : header file
//

#ifndef _DIB_SECTION_H_
#define _DIB_SECTION_H_

class CDIBSection
{
public:

	CDIBSection();
	virtual ~CDIBSection();

	BOOL Load(LPCTSTR pszFileName);
	BOOL Load(HINSTANCE hInstance, LPCTSTR pszResourceName);
	void Unload();

	operator HBITMAP() const;
	
	CSize GetImageSize() const;
	CSize GetBitmapSize() const;
	WORD GetColorDepth() const;

	PBYTE GetBits() const;
	PBYTE GetOriginalBits() const;
	CPalette* GetPalette() const;
	void SetPalette(CPalette& palNew);

	void Draw(CDC* pdc, const CRect& rcBounds) const;
	void ResetBits();
	void ResetPalette();

protected:

	CSize m_sizeImage, m_sizeBitmap;
	int m_nSize;
	WORD m_wColorDepth;
	HBITMAP m_hBitmap;
	PBYTE m_pbyBits, m_pbyOriginalBits;
	CPalette* m_pPalette;
	CPalette* m_pOriginalPalette;

	HBITMAP LoadDIBSection(HINSTANCE hInstance, LPCTSTR pszName);
	void UnloadDIBSection();
	void CreatePalette(HBITMAP hBitmap, WORD wColorDepth);
};

#endif

//////////////////////////////////////////////////////////
