// This program demonstrates a problem
// that shows up in both Visual C++ and
// Borland C++.  In main(), the function
// MakeFoo() is called to create an object
// of type Foo, which does not yet have
// a complete type definition.  This is okay,
// but later in main(), the destructor for
// the Foo object is called.  Since the program
// doesn't have a definition for class Foo
// yet, the destructor for Foo can't be called.
// However, the compiler generates code
// without a warning, meaning the expected
// invocation of the destructor never happens!
//

#include "iostream.h"

class Boo {
    public:
    Boo () { cout << "Boo::Boo()\n"; }
    ~Boo () { cout << "Boo::~Boo()\n"; }
};

class Foo;

Foo *MakeFoo();
Boo *MakeBoo();

int main() {
    Foo *foo;
    Boo *boo;

    boo = MakeBoo();
    foo = MakeFoo();
    delete boo;
    delete foo;
    return 1;
}

class Foo {
    public:
        Foo () { cout << "Foo::Foo()\n"; }
       ~Foo () { cout << "Foo::~Foo()\n"; }
};


Foo *MakeFoo()
{    return new Foo;    }


Boo *MakeBoo()
{    return new Boo;    }


