#include <windows.h>
#include "rpctips.h"

void FormatNSName(const char * pCurrentDomain,
                  const char * pSearchDomain,
                  const char * pBareNSName,
                  char * pFormattedNSName)
{
  /*
     pCurrentDomain is the domain we are currently running in
     pSearchDomain is the domain we want to search
     pBareNSName is the Name Service entry we want to search for
     pFormattedNSName will be returned as the formatted name to
       search for -- note that it must be big enough to hold
       the returned name (no error checking is done for this)
   */

  if (strcmp(pCurrentDomain, pSearchDomain) == 0)
  {
    // Use same-domain name syntax
    strcpy(pFormattedNSName, "/.:/");
  }
  else
  {
    // Use other-domain name syntax
    strcpy(pFormattedNSName, "/.../");
    strcat(pFormattedNSName, pSearchDomain);
    strcat(pFormattedNSName, "/");
  }

  strcat(pFormattedNSName, pBareNSName);
}
