//
// NOV96.CPP
//
// This program demonstrates a problem with the Visual C++
// 4.x compiler.  When attempting to destroy a 0 length
// array via a virtual function, a GPF occurs.  This
// seems to be due to the fact that the compiler generates
// code to find the virtual destructor via the vtable of
// the first element.  Since there is no first element,
// this causes a fault.
//
#include <iostream.h>

class base
{
    public :
        int m_i;
        virtual ~base() {
            cout << "in dtor for base class\n"
                 << flush;
        }
};

class foo : public base
{
    public :
        foo( int i = 5 ) {
            m_i = i;
            cout << "in ctor for derived class foo\n"
                 << flush;
        }
};

void delete_foo( foo *p )
{
    delete[] p;
}

main()
{
    int i = 3;
    cout << "\nCreating foo[ 3 ]\n\n";
    foo *p = new foo[ i ];
    cout << "\nDestroying foo[ 3 ]\n\n";
    delete_foo( p );

    i = 0;
    cout << "\nCreating foo[ 0 ]\n\n";
    p = new foo[ i ];
    cout << "\nDestroying foo[ 0 ]\n\n";
    delete_foo( p );

    return 1;
}
//EOF
