// wdjsrvc.c

#include <windows.h>

HANDLE  hDoneEvent = NULL, hThread = NULL;
DWORD   dwCurrentState;
SERVICE_STATUS_HANDLE  hService;

BOOL NotifySCM(DWORD, DWORD, DWORD);
VOID WINAPI ServiceMain(DWORD, LPTSTR *);
VOID WINAPI ServiceHandler(DWORD);
BOOL WINAPI CtrlHandler(DWORD dwCtrlType);
DWORD WINAPI WorkerThread(LPVOID);

//-----------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hPrev,
    LPSTR lpCmdLine, int nCmdShow)
{
    SERVICE_TABLE_ENTRY ServiceTable[] = {
        {TEXT("WDJSrvc"), ServiceMain}, {NULL, NULL}
    };
    StartServiceCtrlDispatcher(ServiceTable);
    return TRUE;
}

//-----------------------------------------------------------------
VOID WINAPI ServiceMain(DWORD dwArgc, LPTSTR *lpszArgv)
{
   DWORD   ThreadId;

   if (!(hService = RegisterServiceCtrlHandler(
                       TEXT("WDJSrvc"), ServiceHandler)))
      return;

   NotifySCM(SERVICE_START_PENDING, 0, 1);

   if (!(hDoneEvent = CreateEvent(NULL, FALSE, FALSE, NULL)))
      return;

   if (!(hThread = CreateThread(0,0,WorkerThread,0,0,&ThreadId))) {
      CloseHandle(hDoneEvent);
      return;
   }

   SetConsoleCtrlHandler(CtrlHandler, TRUE);

   NotifySCM(SERVICE_RUNNING, 0, 0);
   WaitForSingleObject(hDoneEvent, INFINITE);
   CloseHandle(hThread);
   CloseHandle(hDoneEvent);
   return;
}

//-----------------------------------------------------------------
VOID WINAPI ServiceHandler(DWORD fdwControl)
{
   TCHAR szDbg[MAX_PATH];
   wsprintf(szDbg, TEXT("WDJSrvc: Service code %d\n"), fdwControl);
   OutputDebugString(szDbg);

    // this service doesn't support pause-continue
    switch(fdwControl) {
        case SERVICE_CONTROL_STOP:
            NotifySCM(SERVICE_STOP_PENDING, 0, 1);
            SetEvent(hDoneEvent);
            NotifySCM(SERVICE_STOPPED, 0, 0);
            break;

        case SERVICE_CONTROL_INTERROGATE:
            NotifySCM(dwCurrentState, 0, 0);
            break;

        default:
            break;
    }
}

//-----------------------------------------------------------------
BOOL NotifySCM(DWORD State, DWORD ExitCode, DWORD Progress)
{
   SERVICE_STATUS ServiceStatus;

   ServiceStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
   ServiceStatus.dwCurrentState = dwCurrentState = State;
   ServiceStatus.dwControlsAccepted = SERVICE_ACCEPT_STOP |
                                      SERVICE_ACCEPT_SHUTDOWN;
   ServiceStatus.dwWin32ExitCode = ExitCode;
   ServiceStatus.dwServiceSpecificExitCode = 0;
   ServiceStatus.dwCheckPoint = Progress;
   ServiceStatus.dwWaitHint = 5000;

   return SetServiceStatus(hService, &ServiceStatus);
}

//-----------------------------------------------------------------
BOOL WINAPI CtrlHandler(DWORD dwCtrlType)
{
   if (dwCtrlType == CTRL_LOGOFF_EVENT) {
       OutputDebugString(TEXT("WDJSrvc: CTRL_LOGOFF_EVENT\n"));
   } else if (dwCtrlType == CTRL_SHUTDOWN_EVENT) {
       OutputDebugString(TEXT("WDJSrvc: CTRL_SHUTDOWN_EVENT\n"));
   } else {
       TCHAR szDbg[MAX_PATH];
       wsprintf(szDbg, TEXT("WDJSrvc: Ctrl code %d\n"));
       OutputDebugString(szDbg);
   }
   return FALSE; // pass to next handler
}

//-----------------------------------------------------------------
DWORD WINAPI WorkerThread(LPVOID ThreadParam)
{
   while (TRUE) {
      Sleep(10000);
      MessageBeep(0);
   }
   return TRUE;
}

