// MTrackerView.h : interface of the CMTrackerView class
//
/////////////////////////////////////////////////////////////////////////////
#include "multrack.h"

class CDerivedMRT : public CMultipleRectTracker
{
public:
   CRect m_rectMax;
   virtual void OnChangingRects(int &dx, int &dy);
};


class CMTrackerView : public CView
{
protected: // create from serialization only
	CMTrackerView();
	DECLARE_DYNCREATE(CMTrackerView)

// Attributes
public:
	CMTrackerDoc* GetDocument();
   CDerivedMRT    m_mrt;
   BOOL           m_bAdding;
   HCURSOR        m_hAddCursor;
   HCURSOR        m_hOldCursor;
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMTrackerView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMTrackerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMTrackerView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnObjectsAdd();
	afx_msg void OnObjectsDelete();
	afx_msg void OnUpdateObjectsDelete(CCmdUI* pCmdUI);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MTrackerView.cpp
inline CMTrackerDoc* CMTrackerView::GetDocument()
   { return (CMTrackerDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
