#include "SetAuto.h"

INT APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevious,
    LPSTR lpsz, int iCmd )
    {
    return DialogBox(hInstance, "DLG_MAIN", NULL,
            (DLGPROC)APP_DlgProc );
    }

LRESULT CALLBACK APP_DlgProc(HWND hDlg, UINT uiMsg, WPARAM wParam,
        LPARAM lParam )
    {
    switch( uiMsg )
        {
        case WM_INITDIALOG:
            OnInitDialog( hDlg );
            break;
        case WM_COMMAND:
            switch( wParam )
                {
                case IDOK:
                    OnSave( hDlg );
                    return 1;
                case IDD_RESTORE:
                    OnRestore( hDlg );
                    return 1;
                case IDCANCEL:
                    EndDialog( hDlg, FALSE );
                    return 0;
                }
        }
    return 0L;
    }


VOID OnInitDialog( HWND hDlg )
    {
    INT i, iVal = ReadRegistry();
    SetDlgItemInt( hDlg, IDC_VALUE, iVal, FALSE );
    for( i=2; i<7; i++ )
        CheckDlgButton( hDlg, IDC_REMOVABLE+i-2,
            !(iVal & (INT)pow(2,i)) );
    }


VOID OnRestore( HWND hDlg )
    {
    INT i, iVal = 149;
    SetDlgItemInt( hDlg, IDC_VALUE, iVal, FALSE );
    for( i=2; i<7; i++ )
        CheckDlgButton( hDlg, IDC_REMOVABLE+i-2,
            !(iVal & (INT)pow(2,i)) );
    SetRegistry( 149 );
    }


VOID OnSave( HWND hDlg )
    {
    INT i, iVal=129;

    for( i=2; i<7; i++ )
        if( !IsDlgButtonChecked( hDlg, IDC_REMOVABLE+i-2 ) )
           iVal |= (INT) pow(2,i);
    SetDlgItemInt( hDlg, IDC_VALUE, iVal, FALSE );
    SetRegistry( iVal );
    }


INT ReadRegistry()
    {
    HKEY hkeySub;
    LONG lrc;
    DWORD dwSize;
    INT iRetVal;

    lrc = RegOpenKeyEx( HKEY_CURRENT_USER, KEY_PATH, 0,
            KEY_READ, &hkeySub );
    if( lrc != ERROR_SUCCESS )  return -1;

    dwSize = sizeof(INT);
    lrc = RegQueryValueEx( hkeySub, KEY_ENTRY, NULL, NULL,
        (LPBYTE)&iRetVal, &dwSize );

    RegCloseKey( hkeySub );
    return iRetVal;
    }

VOID SetRegistry( INT iNewVal )
    {
    HKEY hkeySub;
    DWORD dwWhat;

    RegCreateKeyEx( HKEY_CURRENT_USER, KEY_PATH, 0, "",
        REG_OPTION_VOLATILE, KEY_ALL_ACCESS, NULL,
        &hkeySub, &dwWhat );
    RegSetValueEx( hkeySub, KEY_ENTRY, 0, REG_DWORD,
        (CONST BYTE *)&iNewVal, sizeof(INT) );
    RegCloseKey( hkeySub );
    return;
    }

