
// __________________________________________________________
//
//                         W3Count.c
//                WWW Page Access Count V1.00
//                08-03-1996 Sven B. Schreiber
//                 100557.177@compuserve.com
// __________________________________________________________

#include <windows.h>
#include <httpfilt.h>

// =================================================================
// CONSTANTS
// =================================================================

#define MAX_RESPONSE_SIZE  65536

// =================================================================
// GLOBAL VARIABLES
// =================================================================

HINSTANCE hInst;

char sDllFile [MAX_PATH];
char sIniFile [MAX_PATH];

char sSectionEvents [] = "Events";
char sTagCount      [] = "<!--!!!-->";

// =================================================================
// AUXILIARY FUNCTIONS
// =================================================================

void Decimal (DWORD dNumber,
              char  *pcNumber,
              DWORD dSize)
    {
    char  cNull = '0';
    DWORD n, i;

    n = dNumber;
    i = dSize;
    while (i)
        {
        *(pcNumber+(--i)) = (LOBYTE (LOWORD (n % 10))) + cNull;
        if (!(n /= 10)) {cNull = ' ';}
        }
    }

// -----------------------------------------------------------------

BOOL GetDataFile (char  sFileExt [],
                  char  sBuffer [],
                  DWORD dSize)
    {
    DWORD i, j;

    j = i = (sDllFile [0] ? (sDllFile [1] == ':' ? 2 : 0) : 0);
    do
        {
        if (sDllFile [i] == '\\' || sDllFile [i] == '.') {j = i;}
        }
    while (sDllFile [i++]);

    if (sDllFile [j] != '.') {j = i - 1;}

    if (j + lstrlen (sFileExt) < dSize)
        {
        for (i = 0; i < j; i++) {sBuffer [i] = sDllFile [i];}
        i = 0;
        do {sBuffer [j++] = sFileExt [i];} while (sFileExt [i++]);
        return TRUE;
        }
    else
        {
        return FALSE;
        }
    }

// -----------------------------------------------------------------

DWORD CountEvent (char sKeyEvent [])
    {
    UINT uCount;
    char sCount [10+1];

    uCount = GetPrivateProfileInt (sSectionEvents,
                                   sKeyEvent,
                                   0,
                                   sIniFile);

    wsprintf (sCount, "%u", ++uCount);
    WritePrivateProfileString (sSectionEvents,
                               sKeyEvent,
                               sCount,
                               sIniFile);
    return uCount;
    }

// -----------------------------------------------------------------

void WriteCount (DWORD dCount,
                 PVOID pData,
                 DWORD dSize)
    {
    char  *pcData;
    DWORD i, j;

    pcData = pData;
    i = 0;
    while (i != dSize)
        {
        j = 0;
        while (((i+j) != dSize) &&
               sTagCount [j] &&
               (*(pcData+i+j) == sTagCount [j]))
            {
            j++;
            }
        if (sTagCount [j])
            {
            i++;
            }
        else
            {
            Decimal (dCount, pcData+i, j);
            i += j;
            }
        }
    }

// =================================================================
// ISAPI INTERFACE
// =================================================================

BOOL WINAPI GetFilterVersion (HTTP_FILTER_VERSION *pVer)
    {
    pVer->dwFilterVersion = HTTP_FILTER_REVISION;

    lstrcpyn (pVer->lpszFilterDesc,
              "SBS W3Count Filter V1.00",
              SF_MAX_FILTER_DESC_LEN);

    pVer->dwFlags = (SF_NOTIFY_URL_MAP            |
                     SF_NOTIFY_SEND_RAW_DATA      |
                     SF_NOTIFY_END_OF_NET_SESSION |
                     SF_NOTIFY_ORDER_LOW          |
                     SF_NOTIFY_NONSECURE_PORT);

    CountEvent (":GetFilterVersion");
    return TRUE;
    }

// -----------------------------------------------------------------

DWORD WINAPI HttpFilterProc (HTTP_FILTER_CONTEXT *pfc,
                             DWORD               NotificationType,
                             VOID                *pvNotification)
    {
    HTTP_FILTER_URL_MAP  *pUrlMap;
    HTTP_FILTER_RAW_DATA *pRawData;

    switch (NotificationType)
        {
        case SF_NOTIFY_URL_MAP:
            pUrlMap = pvNotification;
            pfc->pFilterContext =
                (PVOID) CountEvent (pUrlMap->pszPhysicalPath);
            break;

        case SF_NOTIFY_SEND_RAW_DATA:
            pRawData = pvNotification;
            WriteCount ((DWORD) pfc->pFilterContext,
                        pRawData->pvInData,
                        pRawData->cbInData);
            break;

        case SF_NOTIFY_END_OF_NET_SESSION:
            CountEvent (":SF_NOTIFY_END_OF_NET_SESSION");
            break;

        default:
            break;
        }
    return SF_STATUS_REQ_NEXT_NOTIFICATION;
    }

// =================================================================
// DLL ENTRY POINT
// =================================================================

BOOL WINAPI DllMain (HINSTANCE hInstance,
                     DWORD     dReason,
                     PVOID     pReserved)
    {
    if (dReason == DLL_PROCESS_ATTACH)
        {
        hInst = hInstance;
        GetModuleFileName (hInst, sDllFile, MAX_PATH);
        return GetDataFile (".ini", sIniFile, MAX_PATH);
        }
    else
        {
        return TRUE;
        }
    }

// =================================================================
// END OF PROGRAM
// =================================================================
