/*
    File: ZDialog.h
    Author: V.Ramachandran
    Date: 18 September, 1996
*/

#ifndef __ZDialog__
#define __ZDialog__

class ZDialog;      // Forward declaration

class ZDialog : public CDialog
{
public:
    ZDialog ();
    ZDialog (UINT nID, CWnd *pParent = NULL);
    ZDialog (LPCSTR lpszTemplateName, CWnd *pParent = NULL);

public:
    virtual BOOL OnInitDialog ();
    BOOL SetCBTHook ();
    BOOL GetByPassState () const { return m_bByPass; }
    void ByPassHook (BOOL bFlag = TRUE)
                { m_bByPass = bFlag; }
    void SetFocusNoHook (UINT nFieldID)
                {
                    m_bByPass = TRUE;
                    ::SetFocus (::GetDlgItem (m_hWnd, nFieldID));
                    m_bByPass = FALSE;
                }

public:     // Overrideables
    virtual BOOL IsValidationReqd (HWND hWndLost, HWND hWndGain);
    virtual BOOL DoValidation (UINT nLostID);
    virtual void NotifyError (UINT nLostID);

protected:
    afx_msg LRESULT OnFocusChangeRequest (WPARAM wParam, 
                            LPARAM lParam);
    afx_msg void OnDestroy ();

protected:
    static LRESULT CALLBACK CBTProc (int nCode, 
                            WPARAM wParam, LPARAM lParam);
    static int m_nNofInstances;
    static HHOOK m_hOldHook;
    static ZDialog * m_pCurrentDlg;
    
protected:
    BOOL m_bByPass;         // If true, hook does nothing
    DECLARE_MESSAGE_MAP()        
    DECLARE_DYNAMIC (ZDialog)
};

#define DO_FIELD_VALIDATION(fieldID)                        \
                        if (!DoValidation (fieldID)) {      \
                            NotifyError (fieldID);              \
                            SetFocusNoHook (fieldID);           \
                            return;                                 \
                        }

#define DO_FIELD_VALIDATION_RETURN(fieldID, ret)        \
                        if (!DoValidation (fieldID)) {      \
                            NotifyError (fieldID);              \
                            SetFocusNoHook (fieldID);           \
                            return ret;                             \
                        }

#endif // __ZDialog__
