#ifndef CSOCKOBJ_H
	#define CSOCKOBJ_H

//Forward Declarations
class CObjectSocket;
class CNetObject;

class CSocketArchive : public CArchive{
public:
	CSocketArchive(CFile * pFile, UINT nMode, int nBufSize=4096): 
			CArchive(pFile, nMode, nBufSize) {};
	void ClearIndex();
};

class CSocketSlave : public CSocket{
	CObjectSocket * m_pMaster;
public:
	CSocketSlave(CObjectSocket * pOS);
	void OnReceive(int nErrorCode);
	void OnClose(int nErrorCode);
};

class CObjectSocket{
protected:
	friend class CSocketSlave;
	CSocketSlave * m_pSocket;
	CSocketFile * m_pSocketFile;
	CSocketArchive * m_pArchiveIn,
				   * m_pArchiveOut;
	void ClearNewPointers();
	void ReadPending();
public:
	CObjectSocket();
	~CObjectSocket();

	BOOL IsConnected() {return (m_pSocket != NULL);}
	BOOL Connect(LPCTSTR lpszHostAddress, UINT nHostPort);
	BOOL Connect(CSocket * pSocket);
	void Disconnect();
	
	BOOL SendObject(CNetObject * pObj);

	virtual void OnForcedDrop();
	virtual void ConnectionClosed();
	virtual void ErrorMemory();
	virtual void ErrorArchive(int nErrorCode);
	virtual void ErrorFile(int nErrorCode);
	virtual void ErrorSocket(int nErrorCode);
};

class CNetObject : public CObject{
public:
	DECLARE_SERIAL(CNetObject)
	CNetObject() {};
	virtual void DoAction(CObjectSocket * pOS);
	void Serialize(CArchive& ar);
};

#endif //CSOCKOBJ_H