// TechTipView.cpp : implementation of the CTechTipView class
//

#include "stdafx.h"
#include "TechTip.h"

#include "TechTipDoc.h"
#include "CntrItem.h"
#include "TechTipView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTechTipView

IMPLEMENT_DYNCREATE(CTechTipView, CTreeView)

BEGIN_MESSAGE_MAP(CTechTipView, CTreeView)
	//{{AFX_MSG_MAP(CTechTipView)
	ON_WM_SETFOCUS()
	ON_WM_SIZE()
	ON_COMMAND(ID_OLE_INSERT_NEW, OnInsertObject)
	ON_COMMAND(ID_CANCEL_EDIT_CNTR, OnCancelEditCntr)
	ON_COMMAND(ID_CANCEL_EDIT_SRVR, OnCancelEditSrvr)
	ON_NOTIFY_REFLECT(TVN_BEGINDRAG, OnBegindrag)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CTreeView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CTreeView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CTreeView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTechTipView construction/destruction

CTechTipView::CTechTipView()
{
	m_pSelection = NULL;
	// TODO: add construction code here
  m_pIStorage       = NULL;
  m_hGlobal         = NULL;
  m_DragSourceItem  = NULL;
}

CTechTipView::~CTechTipView()
{
}

BOOL CTechTipView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style |= TVS_HASLINES;

	return CTreeView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTechTipView drawing

void CTechTipView::OnDraw(CDC* pDC)
{
	CTechTipDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	// TODO: also draw all OLE items in the document

	// Draw the selection at an arbitrary position.  This code should be
	//  removed once your real drawing code is implemented.  This position
	//  corresponds exactly to the rectangle returned by CTechTipCntrItem,
	//  to give the effect of in-place editing.

	// TODO: remove this code when final draw code is complete.

	if (m_pSelection == NULL)
	{
		POSITION pos = pDoc->GetStartPosition();
		m_pSelection = (CTechTipCntrItem*)pDoc->GetNextClientItem(pos);
	}
	if (m_pSelection != NULL)
		m_pSelection->Draw(pDC, CRect(10, 10, 210, 210));
}

void CTechTipView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();

	// TODO: You may populate your TreeView with items by directly accessing
	//  its tree control through a call to GetTreeCtrl().

	// TODO: remove this code when final selection model code is written
	m_pSelection = NULL;    // initialize selection

}

/////////////////////////////////////////////////////////////////////////////
// CTechTipView printing

BOOL CTechTipView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CTechTipView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CTechTipView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// OLE Client support and commands

BOOL CTechTipView::IsSelected(const CObject* pDocItem) const
{
	// The implementation below is adequate if your selection consists of
	//  only CTechTipCntrItem objects.  To handle different selection
	//  mechanisms, the implementation here should be replaced.

	// TODO: implement this function that tests for a selected OLE client item

	return pDocItem == m_pSelection;
}

void CTechTipView::OnInsertObject()
{
	// Invoke the standard Insert Object dialog box to obtain information
	//  for new CTechTipCntrItem object.
	COleInsertDialog dlg;
	if (dlg.DoModal() != IDOK)
		return;

	BeginWaitCursor();

	CTechTipCntrItem* pItem = NULL;
	TRY
	{
		// Create new item connected to this document.
		CTechTipDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);
		pItem = new CTechTipCntrItem(pDoc);
		ASSERT_VALID(pItem);

		// Initialize the item from the dialog data.
		if (!dlg.CreateItem(pItem))
			AfxThrowMemoryException();  // any exception will do
		ASSERT_VALID(pItem);

		// If item created from class list (not from file) then launch
		//  the server to edit the item.
		if (dlg.GetSelectionType() == COleInsertDialog::createNewItem)
			pItem->DoVerb(OLEIVERB_SHOW, this);

		ASSERT_VALID(pItem);

		// As an arbitrary user interface design, this sets the selection
		//  to the last item inserted.

		// TODO: reimplement selection as appropriate for your application

		m_pSelection = pItem;   // set selection to last inserted item
		pDoc->UpdateAllViews(NULL);
	}
	CATCH(CException, e)
	{
		if (pItem != NULL)
		{
			ASSERT_VALID(pItem);
			pItem->Delete();
		}
		AfxMessageBox(IDP_FAILED_TO_CREATE);
	}
	END_CATCH

	EndWaitCursor();
}

// The following command handler provides the standard keyboard
//  user interface to cancel an in-place editing session.  Here,
//  the container (not the server) causes the deactivation.
void CTechTipView::OnCancelEditCntr()
{
	// Close any in-place active item on this view.
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL)
	{
		pActiveItem->Close();
	}
	ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
}

// Special handling of OnSetFocus and OnSize are required for a container
//  when an object is being edited in-place.
void CTechTipView::OnSetFocus(CWnd* pOldWnd)
{
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL &&
		pActiveItem->GetItemState() == COleClientItem::activeUIState)
	{
		// need to set focus to this item if it is in the same view
		CWnd* pWnd = pActiveItem->GetInPlaceWindow();
		if (pWnd != NULL)
		{
			pWnd->SetFocus();   // don't call the base class
			return;
		}
	}

	CTreeView::OnSetFocus(pOldWnd);
}

void CTechTipView::OnSize(UINT nType, int cx, int cy)
{
	CTreeView::OnSize(nType, cx, cy);
	COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
	if (pActiveItem != NULL)
		pActiveItem->SetItemRects();
}

/////////////////////////////////////////////////////////////////////////////
// OLE Server support

// The following command handler provides the standard keyboard
//  user interface to cancel an in-place editing session.  Here,
//  the server (not the container) causes the deactivation.
void CTechTipView::OnCancelEditSrvr()
{
	GetDocument()->OnDeactivateUI(FALSE);
}

/////////////////////////////////////////////////////////////////////////////
// CTechTipView diagnostics

#ifdef _DEBUG
void CTechTipView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CTechTipView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}

CTechTipDoc* CTechTipView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTechTipDoc)));
	return (CTechTipDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTechTipView message handlers

//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

void CTechTipView::OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	//*pResult = 0;

	m_DragSourceItem  = NULL;
	CTreeCtrl&		TreeCtrl = GetTreeCtrl();

	// if it is a root, it can't be dragged
	if (pNMTreeView->itemNew.lParam != -1) 
	{
		// get parent item
		HTREEITEM hParent = TreeCtrl.GetParentItem( pNMTreeView->itemNew.hItem );

		// if item we are dragging is the only one child of the root item do nothing
		HTREEITEM hRoot = TreeCtrl.GetRootItem();
		if ( hRoot == hParent )
		{
		  HTREEITEM hSibling = TreeCtrl.GetNextItem( pNMTreeView->itemNew.hItem, TVGN_NEXT );
		  if ( hSibling == NULL )
		  {
			  // item already exists here do nothing
			  hSibling = TreeCtrl.GetNextItem( pNMTreeView->itemNew.hItem, TVGN_PREVIOUS );
			  if ( hSibling == NULL )
			  {
			    return;
			  }
		  }
		}

		// put data into the archive
		if ( copyTreeBranch ( pNMTreeView->itemNew.hItem ) )
		{
			COleDataSource srcItem;
			UINT	nClipFormat = ((CTechTipApp*)AfxGetApp())->m_nClipFormat;
			srcItem.CacheGlobalData( nClipFormat, m_hGlobal );

			// indicates the branch from where that drag and drop was initiated
		 	m_DragSourceItem  = pNMTreeView->itemNew.hItem;

			DROPEFFECT retVal = srcItem.DoDragDrop();

			m_pIStorage->Release();
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

DROPEFFECT CTechTipView::OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point) 
{
	// TODO: Add your specialized code here and/or call the base class
	UINT	nClipFormat = ((CTechTipApp*)AfxGetApp())->m_nClipFormat;
	if ( pDataObject->IsDataAvailable(nClipFormat ) )
	{
		return DROPEFFECT_COPY;
	}
	
	
	return CTreeView::OnDragEnter(pDataObject, dwKeyState, point);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

void CTechTipView::OnDragLeave() 
{
	// TODO: Add your specialized code here and/or call the base class
	CTreeCtrl&	TreeCtrl = GetTreeCtrl();
	TreeCtrl.SelectDropTarget(NULL);
	CTreeView::OnDragLeave();
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

DROPEFFECT CTechTipView::OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point) 
{
	// TODO: Add your specialized code here and/or call the base class
	UINT	nClipFormat = ((CTechTipApp*)AfxGetApp())->m_nClipFormat;
	if ( pDataObject->IsDataAvailable( nClipFormat ) )
	{
		CTreeCtrl&	TreeCtrl = GetTreeCtrl();
		TV_HITTESTINFO tvHit;

		tvHit.pt.x = point.x;
		tvHit.pt.y = point.y;

		HTREEITEM hTarget;
		if (NULL != (hTarget = TreeCtrl.HitTest(&tvHit)))
		{
			TV_ITEM tvi;           
			tvi.mask = TVIF_PARAM;
			tvi.hItem = hTarget;
			TreeCtrl.GetItem(&tvi);

			if ( hTarget != TreeCtrl.GetDropHilightItem() )
			{							
				ImageList_DragShowNolock(FALSE);
				TreeCtrl.SelectDropTarget(hTarget);
				ImageList_DragShowNolock(TRUE);
			}
		}

		return DROPEFFECT_COPY;
	}
	return CTreeView::OnDragOver(pDataObject, dwKeyState, point);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CTechTipView::OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point) 
{
	// TODO: Add your specialized code here and/or call the base class
  USES_CONVERSION;
  CWaitCursor wait;	// display wait cursor

  if ( pDataObject->IsDataAvailable( ((CTechTipApp*)AfxGetApp())->m_nClipFormat ) )
  {
	  CTreeCtrl&	TreeCtrl = GetTreeCtrl();
	  TreeCtrl.SelectDropTarget(NULL);

	  HGLOBAL hGlob = pDataObject->GetGlobalData(((CTechTipApp*)AfxGetApp())->m_nClipFormat );
    if ( !hGlob )
    {
      m_DragSourceItem  = NULL;
      return FALSE;
    }

    // create  ILockBytes inteface
    // ===========================
    ILockBytes*  pLockByte;
    CreateILockBytesOnHGlobal ( hGlob, TRUE, &pLockByte );

    DWORD grfMode = STGM_DIRECT | STGM_READWRITE | STGM_SHARE_EXCLUSIVE; 
    IStorage* ppstgOpen;
    if ( S_OK != StgOpenStorageOnILockBytes(
        pLockByte, 	          //Points to the ILockBytes interface on the underlying byte array
        NULL, 	              //Points to a previous opening of a root storage object
        grfMode, 	            //Specifies the access mode for the object
        NULL, 	              //Points to an SNB structure specifying elements to be excluded
        0, 	                  //Reserved, must be zero
        &ppstgOpen ) )         //Points to location for returning the storage object
    {
      m_DragSourceItem  = NULL;
      return FALSE;
    }

      // drop
      // ===========================
	  TV_ITEM         tvi;           
	  TV_HITTESTINFO tvht;

	  tvht.pt.x = point.x;
	  tvht.pt.y = point.y;
	  HTREEITEM hTarget = TreeCtrl.HitTest(&tvht);

	  if (NULL != hTarget) // Can't drop on nothing
	  {
		  tvi.mask = TVIF_PARAM;
		  tvi.hItem = hTarget;
		  TreeCtrl.GetItem(&tvi);

		  if ( tvi.lParam != -1 && tvi.lParam < 0 )    // Can't drop on leaf
		  {
			  m_DragSourceItem  = NULL;
			  return FALSE;
		  }

		  BOOL bRes = readTreeBranch(ppstgOpen, hTarget, TreeCtrl.GetItemText(hTarget) );
		  ppstgOpen->Release ();

		  // only for drag and drop within the same address space.
		  if ( bRes && m_DragSourceItem )
		  {
			  TreeCtrl.DeleteItem (m_DragSourceItem); 
			  m_DragSourceItem = NULL;
		  }
	  }
  }
	
  m_DragSourceItem  = NULL;
  return TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CTechTipView::copyTreeBranch ( HTREEITEM hRootItem )
{
  USES_CONVERSION;
  CWaitCursor   hourGlass;
  if ( hRootItem == NULL ) 
    return FALSE;

  // allocate memory
  ILockBytes*  pLockByte;
  m_hGlobal = GlobalAlloc ( GMEM_MOVEABLE | 
                            GMEM_SHARE    | 
                            GMEM_ZEROINIT | 
                            GMEM_NODISCARD,
                            0
                          );
  if ( !m_hGlobal )
    return FALSE;

  CreateILockBytesOnHGlobal ( m_hGlobal, TRUE, &pLockByte );


  HRESULT hr = StgCreateDocfileOnILockBytes( pLockByte, 
                         STGM_DIRECT | 
                         STGM_READWRITE | 
                         STGM_CREATE | 
                         STGM_SHARE_EXCLUSIVE, 
                         0, 
                         &m_pIStorage);

  if (FAILED(hr))
    return FALSE;

  // get root item
  // ==============
  serializeTree ( &m_pIStorage, hRootItem );

  return TRUE;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

void CTechTipView::serializeTree ( LPSTORAGE*  ppIStorage, 
                                  HTREEITEM   hThisItem 
                                 )
{
  // serialize it
  CTreeCtrl&	TreeCtrl = GetTreeCtrl();
  BOOL bCreateSubStorage = TreeCtrl.ItemHasChildren( hThisItem );

  IStorage* ppNewStg;
  if ( !(ppNewStg = serializeItem( hThisItem, *ppIStorage, bCreateSubStorage ) ) )
  {
    return;
  }

  if ( !bCreateSubStorage )
  {
    return;
  }


  HTREEITEM   hChild = TreeCtrl.GetNextItem( hThisItem, TVGN_CHILD );

  while ( hChild )
  {
    serializeTree(&ppNewStg, hChild );
    hChild = TreeCtrl.GetNextItem( hChild, TVGN_NEXT );
  }
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// PURPOSE: It creates stream for leaf element (element with no children).
//          If  the element has children (it is a group) we also create
//          substorage for this element with the same name as a stream. 

IStorage* CTechTipView::serializeItem( HTREEITEM  hItem,
                                      IStorage*  ppstg, 
                                      BOOL       bCreateSubStorage )
{
  // go through all items
  USES_CONVERSION;

  CString     strItemName;
  int         nLen = 1024;
  strItemName.GetBufferSetLength(nLen);

  TV_ITEM             tvItem;
  tvItem.mask       = TVIF_TEXT           | 
                      TVIF_PARAM          | 
                      TVIF_STATE          | 
                      TVIF_IMAGE          | 
                      TVIF_SELECTEDIMAGE  | 
                      TVIF_CHILDREN;

  tvItem.pszText    = strItemName.GetBufferSetLength(nLen);
  tvItem.cchTextMax = nLen;
  tvItem.hItem      = hItem;

  CTreeCtrl&	TreeCtrl = GetTreeCtrl();
  TreeCtrl.GetItem (&tvItem);
  strItemName.ReleaseBuffer();

  // get parent item
  // ---------------
  HTREEITEM   hParentItem = TreeCtrl.GetParentItem(hItem);
  long    lParentID = -1;
  CString csParentName(_T(""));

  if ( hParentItem )
  {
    lParentID = TreeCtrl.GetItemData(hParentItem);
    csParentName = TreeCtrl.GetItemText(hParentItem);
  }

  // create certain type of stream which keeps data for the group item
  // -----------------------------------------------------------------
  CString   strStreamName;
  if ( bCreateSubStorage )
    strStreamName = strItemName + SPECIAL_STREAM_TOKEN;
  else
    strStreamName = strItemName;

  // create stream in this substorage
  // ----------------------------
  COleStreamFile    oleStreamTVitem;
  if ( FALSE == oleStreamTVitem.CreateStream( ppstg, strStreamName ) )
    return NULL;

  // save to Contents stream
  // ----------------------------
  CArchive saveArchive(&oleStreamTVitem, CArchive::store | CArchive::bNoFlushOnDelete);
  
  serializeTVItem ( saveArchive, 
					          strStreamName, 
					          tvItem.iImage, 
					          tvItem.iSelectedImage,
					          tvItem.lParam
				         );

  saveArchive.Close();
  oleStreamTVitem.Close();

  // create substorage for child
  // ----------------------------
  IStorage* newppstg = NULL;
  if ( bCreateSubStorage )
  {
    // create substorage which is the synonym of a group
    // --------------------------------------------------
    strStreamName = strItemName + STORAGE_TOKEN;
    LPCOLESTR yuy = T2COLE(strStreamName);

    DWORD     dwMode = STGM_DIRECT | STGM_READWRITE| STGM_SHARE_EXCLUSIVE ;
    HRESULT   hr = ppstg->CreateStorage(
      yuy, 	    //Points to the name of the new storage object
      dwMode,	  //Access mode for the new storage object
      0,	      //Reserved; must be zero
      0,	      //Reserved; must be zero
      &newppstg	//Points to new substorage object
      );

    if ( FAILED(hr) )
      return NULL;
  }

  return newppstg;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CTechTipView::readTreeBranch(IStorage* lpOpenStorage, HTREEITEM hTarget, CString csRoot )
{
  USES_CONVERSION;

  IEnumSTATSTG* lpEnum;
  HRESULT hr = lpOpenStorage->EnumElements ( 0, NULL, 0, &lpEnum );
  if ( FAILED (hr) )
    return FALSE;

  STATSTG       sstg;
  while (lpEnum->Next(1, (STATSTG*)&sstg, NULL) == NOERROR )
  {
    CString strStorage = OLE2CT(sstg.pwcsName);
    if ( sstg.type == STGTY_STORAGE )
    {
      IStorage*   lpSubStorage=NULL;
      DWORD     dwMode =  STGM_DIRECT | STGM_READWRITE | STGM_SHARE_EXCLUSIVE ;

      hr = lpOpenStorage->OpenStorage(
        sstg.pwcsName,	//Points to the name of the storage object to open
        NULL,	          //Points to previous opening of the storage object
        dwMode,         //Access mode for the new storage object
        NULL,	          //Points to a block of stream names in the storage object
        0,	            //Reserved; must be zero
        &lpSubStorage	);//Points to opened storage object

      if ( FAILED(hr) )
        return FALSE;

      // Now when we found the substorage position we need to go back and find stream
      // which describes this substorage. That stream should have the same base name 
      // as the substorage has except for TOKENS ( see otarget.h ).
      // We set a bookmark on the enumarator interface - by cloning it and start 
      // enumerating again from the begining

      IEnumSTATSTG* lpEnumBookmark;
      HRESULT hr = lpEnum->Clone ( &lpEnumBookmark );
      if ( FAILED (hr) )
        return FALSE;

      STATSTG       sstgTemp;
      while (lpEnumBookmark->Next(1, (STATSTG*)&sstgTemp, NULL) == NOERROR )
      {
        if ( sstgTemp.type == STGTY_STREAM )
        {
          CString strTemp = OLE2CT(sstgTemp.pwcsName);
          int nFindToken = strTemp.Find ( SPECIAL_STREAM_TOKEN );
          if ( nFindToken )
          {
            // make sure that it is the same buffer
            // ====================================
            CString csStreamName  = strTemp.Left(nFindToken) + STORAGE_TOKEN;
            if ( csStreamName != strStorage )
              continue;

            // we found it now load 
            // =================================
            COleStreamFile    oleStreamGroup;
            if ( FALSE == oleStreamGroup.OpenStream( lpOpenStorage, OLE2CT(sstgTemp.pwcsName) ) )
              return FALSE;

            CArchive saveArchive(&oleStreamGroup, CArchive::load);

            LPARAM          lID;

            int         nGroupImage;
            int         nGroupSelectedImage;
            CString     strGroupItemName;
            int         nGroupLen = 1024;
            strGroupItemName.GetBufferSetLength(nGroupLen);

            serializeTVItem( saveArchive, 
                             strGroupItemName, 
                             nGroupImage, 
                             nGroupSelectedImage,
                             lID
                             );

            saveArchive.Close();
            oleStreamGroup.Close();

            strGroupItemName.ReleaseBuffer();

            nFindToken = strGroupItemName.Find (SPECIAL_STREAM_TOKEN );
            if ( nFindToken )
              strGroupItemName = strGroupItemName.Left(nFindToken);

            if ( FALSE == csRoot.IsEmpty() )
            {
              if ( strGroupItemName == csRoot )
              {
                // can't drop on itself
                AfxMessageBox ( "Target and Destination are the same, operation aborted!" );
                csRoot.Empty();
                return FALSE;
              }
              csRoot.Empty();
            }


            HTREEITEM hItem = addTreeNode( hTarget, 
                                           strGroupItemName, 
                                           nGroupImage, 
                                           nGroupSelectedImage,
                                           lID
                                          );
      
            readTreeBranch(lpSubStorage, hItem, csRoot );

            // restore the state of the enumerator interface and exit
            break;
            // =========================================
          }
        }
      }
    }
    else if ( sstg.type == STGTY_STREAM )
    {
      COleStreamFile    oleStreamTVitem;
      if ( FALSE == oleStreamTVitem.OpenStream( lpOpenStorage, OLE2CT(sstg.pwcsName) ) )
      {
        return FALSE;
      }

      // load 
      // ----------------------------
      CArchive saveArchive(&oleStreamTVitem, CArchive::load);

      LPARAM          lID;

      int         nImage;
      int         nSelectedImage;
      CString     strItemName;
      int         nLen = 1024;
      strItemName.GetBufferSetLength(nLen);

      serializeTVItem(saveArchive, 
                      strItemName, 
                      nImage, 
                      nSelectedImage,
                      lID
                      );

      saveArchive.Close();
      oleStreamTVitem.Close();
      strItemName.ReleaseBuffer();

      int nFindToken = strItemName.Find (SPECIAL_STREAM_TOKEN);
      if ( -1 == nFindToken )
      {
        addTreeNode ( hTarget, 
                      strItemName, 
                      nImage, 
                      nSelectedImage,
                      lID
                      );
      }

      else
      {
        // do it only once 
        if ( FALSE == csRoot.IsEmpty() )
        {
          strItemName = strItemName.Left(nFindToken);
          if ( strItemName == csRoot )
          {
            // can't drop on itself
            AfxMessageBox ( "Target and Destination are the same, operation aborted!" );
            csRoot.Empty();
            return FALSE;
          }
          csRoot.Empty();
        }
      }
    }
  }
  return TRUE;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

void CTechTipView::serializeTVItem( CArchive&       ar, 
                                  CString&        strName,
                                  int&            nImage,
                                  int&            nSelectedImage,
                                  LPARAM&         lID
                                  )
{
  if ( ar.IsStoring() )
  {
    ar << strName;
    ar << nImage;
    ar << nSelectedImage;
    ar << lID;
  }
  else
  {
    ar >> strName;
    ar >> nImage;
    ar >> nSelectedImage;
    ar >> lID;
  }
}



//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

HTREEITEM CTechTipView::addTreeNode( HTREEITEM hTarget, 
                                   CString    strName,
                                   int        nImage,
                                   int        nSelectedImage,
                                   LPARAM     lID
                              )
{
  CTreeCtrl&	TreeCtrl = GetTreeCtrl();
	TV_INSERTSTRUCT TreeCtrlItem;
	TreeCtrlItem.item.mask    = TVIF_TEXT  | 
                              TVIF_PARAM | 
		                          TVIF_IMAGE | 
                              TVIF_SELECTEDIMAGE;
  
  TreeCtrlItem.hParent              = hTarget;
  TreeCtrlItem.hInsertAfter         = TVI_LAST;
  TreeCtrlItem.item.pszText         = strName.GetBuffer(0);
  TreeCtrlItem.item.cchTextMax      = strName.GetLength();
  TreeCtrlItem.item.lParam          = lID;
  TreeCtrlItem.item.iImage          = nImage;
  TreeCtrlItem.item.iSelectedImage  = nSelectedImage;
  HTREEITEM  hItem = TreeCtrl.InsertItem(&TreeCtrlItem);
  strName.ReleaseBuffer();

  return hItem;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

int CTechTipView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CTreeView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	CTechTipApp*  pApp = (CTechTipApp*)AfxGetApp();

	CTreeCtrl&	TreeCtrl = GetTreeCtrl();
	TreeCtrl.SetImageList(&pApp->m_imgList,TVSIL_NORMAL);

	CString    strTemp;
	CString    strGroup(_T("Group %d") );
	CString    strSubGroup(_T("SubGroup %d") );
	CString    strNode1(_T("Blue Leaf %d") );
	CString    strNode2(_T("Grey Leaf %d") );
	HTREEITEM hRoot = addTreeItem ( (HTREEITEM)NULL,
											CString (_T("Root Item")),
											1,   
											1,
											-1
											);      
	int   nTemp1, nTemp2, nTemp3, nTemp4;

	HTREEITEM   hParent, hTemp;
	for ( int nInd = 0; nInd < 4; nInd++ )
	{
		nTemp1 = 1000*(nInd+1);
		strTemp.Format(strGroup.GetBuffer(0), nTemp1);
		hParent = addTreeItem ( hRoot,
								  strTemp,
								  1,   
								  0,
								  nTemp1
								  ); 
		strGroup.ReleaseBuffer(-1);
		hTemp = hParent;
		for ( int nJ = 0; nJ < 5; nJ++ )
		{
		  nTemp2 = (nJ+1)*100;
		  strTemp.Format(strSubGroup.GetBuffer(0), nTemp1 + nTemp2);
		  hParent = addTreeItem ( hTemp,
									strTemp,
									1,   
									0,
									nTemp1 + nTemp2
									); 
		  strSubGroup.ReleaseBuffer(-1);
		  for ( int nI = 0; nI < 7; nI++ )
		  {
			nTemp3 = (nI + 1)*10;
			strTemp.Format(strNode1.GetBuffer(0), -(nTemp1 + nTemp2 + nTemp3));
			addTreeItem ( hParent,
						strTemp,
						2,  
						2,
						-(nTemp1 + nTemp2 + nTemp3)
						);
			strNode1.ReleaseBuffer(-1);
		  }
		}

		for ( int nK = 0; nK < 8; nK++ )
		{
		  nTemp4 = nK + 1;
		  strTemp.Format(strNode2.GetBuffer(0), -(nTemp1+nTemp4));
		  addTreeItem ( hTemp,
					  strTemp,
					  3,  // leaf icon
					  3,
					  -(nTemp1+nTemp4)
					  );
		  strNode2.ReleaseBuffer(-1);
		}
	}

	TreeCtrl.Expand(hRoot, TVE_EXPAND);
	m_dropTarget.Register(this);
	return 0;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////////////////////////////////////////////////////////

HTREEITEM CTechTipView::addTreeItem(
							              HTREEITEM		hParentItem,
                            CString			csItemText,
                            int				nImage,
                            int				nSelImage,
                            long			lID
						                ) 
{
	CWaitCursor		hourGlass;
	CTreeCtrl&		TreeCtrl = GetTreeCtrl();

	TV_INSERTSTRUCT   TreeCtrlItem;

	TreeCtrlItem.item.mask    = TVIF_TEXT  | 
								              TVIF_PARAM | 
								              TVIF_STATE |
		                          TVIF_IMAGE | 
								              TVIF_SELECTEDIMAGE;
  
	TreeCtrlItem.hInsertAfter = TVI_LAST;
	
	// if there is no parent it is the root
	if ( hParentItem == NULL )               
		TreeCtrlItem.hParent = TVI_ROOT;
	else
		TreeCtrlItem.hParent = hParentItem;

	TreeCtrlItem.item.pszText         = csItemText.GetBuffer(0);
	TreeCtrlItem.item.cchTextMax      = csItemText.GetLength();
	TreeCtrlItem.item.lParam          = lID;
	TreeCtrlItem.item.iImage          = nImage;
	TreeCtrlItem.item.iSelectedImage  = nSelImage;

	HTREEITEM   hTemp = TreeCtrl.InsertItem(&TreeCtrlItem);

	csItemText.ReleaseBuffer(-1);
  
	return hTemp;
}

