#include <windows.h>

#define _MYLIB_
#include "Exwait32.h"
#undef MYLIBAPI
#define MYLIBAPI __declspec(dllexport)

#ifdef __cplusplus
extern "C" {
#endif

MYLIBAPI short CALLSEQ ExecProg(LPCSTR lpCmd, LPCSTR lpParam, int nCmdShow, LPDWORD retCode)
{
	SHELLEXECUTEINFO sei = {
		sizeof(SHELLEXECUTEINFO),
		SEE_MASK_NOCLOSEPROCESS | SEE_MASK_FLAG_NO_UI,
		NULL,					// hwnd of parent m_hWnd is a MFC thing, just a plain HWND var 
		"Open",                 // lpVerb  could be any "verb" open is the same as a double-click.
		lpCmd,					//can be ANY file                      
		lpParam,
		NULL,
		nCmdShow,				// nShow
		NULL,					// hInstApp is for MFC apps, just need the hInstance var.
		(LPVOID)NULL,           // lpIDList...will set below complicated PIDL stuff, not needed
		NULL,                   // lpClass
		0,                      // hkeyClass
		0,                      // dwHotKey
		NULL					// hIcon
	};

    if (ShellExecuteEx(&sei))
	{
		WaitForSingleObject(sei.hProcess, INFINITE);
		// Process has terminated
		GetExitCodeProcess(sei.hProcess, (LPDWORD)retCode);
		return 1;	// OK
	}
	else
	{
		// Process could not be started
		*retCode = GetLastError();
		
		return 0;	// FAILED
	}
}

MYLIBAPI short CALLSEQ ExecProgP( LPCTSTR lpCmd, LPTSTR lpParam, WORD nCmdShow, LPDWORD retCode)
{
	STARTUPINFO StartupInfo = {0};
	PROCESS_INFORMATION ProcessInfo = {0};
	LPVOID lpMsgBuf;
//	CHAR buf[30];
	
	StartupInfo.cb = sizeof(STARTUPINFO);
	StartupInfo.dwFlags = STARTF_USESHOWWINDOW;
	StartupInfo.wShowWindow = nCmdShow;


	if (CreateProcess(lpCmd, lpParam, NULL, NULL, FALSE,
		NORMAL_PRIORITY_CLASS, NULL, NULL, &StartupInfo, &ProcessInfo))
	{
		WaitForSingleObject(ProcessInfo.hProcess, INFINITE);
		/* Process has terminated */
		GetExitCodeProcess(ProcessInfo.hProcess, retCode);
//		wsprintf(buf, "Return code: %d", *lpExitCode);
//		MessageBox(NULL, buf, "EXWAIT", MB_OK);
		return 1;	// OK
	}
	else
	{
		/* Process could not be started */
		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
			NULL,
			*retCode = GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
		);
		
//		wsprintf(buf, "Return code: %d", *lpExitCode);
//		MessageBox(NULL, buf, "EXWAIT", MB_OK);

		// Display the string.
//		MessageBox( NULL, lpMsgBuf, "GetLastError", MB_OK|MB_ICONINFORMATION );

		// Free the buffer.
		LocalFree( lpMsgBuf );
		return 0;	// FAILED
	}
}

BOOL WINAPI DllMain( HANDLE hModule, 
                        DWORD dwReason, 
                        LPVOID lpReserved )
{
    return TRUE;
}

#ifdef __cplusplus
    };
#endif

