// Sample Console Application for testing bug in
// NetServerGetInfo API 
//            BuggyServer.CPP
//      Compiler - MSVC++ 4.2
     
#include <stdio.h>
#include <windows.h>
#include <lm.h>
extern "C"
{
     
     
void wmain(int argc, wchar_t * argv[]) 
{
     
 NET_API_STATUS nas;
     
 LPSERVER_INFO_100 lpBuffer1;
 LPSERVER_INFO_101 lpBuffer2;
     
     
 // Print out Usage String if improper command line specified. 
 if ( argc != 2 )
 {
  wprintf(L"Usage :\nBuggyServer \\\\<Computer Name>\n"); 
  exit(0);
 }
     
     
 // First give a try for level 100 call which, 
 // being a lowest level call, is supposed to succeed.
     
 nas = NetServerGetInfo(
       argv[1], 
       100,
       (LPBYTE *)&lpBuffer1
        );
     
     
 if (nas == NERR_Success)
 {
  wprintf(L"\nLevel 100 call Success \nComputer Name = %s",
lpBuffer1->sv100_name);
  NetApiBufferFree (lpBuffer2);
     
 }
 else
 { 
  // If 100 level call fails we try 101 level call, 
  // which succeedes if machine is running Win95.
     
  wprintf(L"\nLevel 100 call failed."); 
  nas = NetServerGetInfo(
        argv[1], 
        101,
        (LPBYTE *)&lpBuffer2
         );
     
  if (nas == NERR_Success)
  {
   wprintf(L"\nLevel 101 call Success \nComputer Name = %s",
lpBuffer2->sv101_name);
   NetApiBufferFree (lpBuffer2);
     
  }
  else
  {
   wprintf(L"\nLevel 101 call failed.");
   wprintf(L"\nCalls at both levels failed. \nThe computer Name"
		   L"may not be correct or may not be specified with"
		   L"leading \\\\\n. ");
     
  } // else of level 101 call.
     
 } // else of level 100 call.
     
} // End wmain.
     
     
} // extern "C"
