// getnic.c -- link with rpcrt4.lib

#include <rpc.h>

// Function to return a unique machine identifier
// as a 12 character string
BOOL GetNICAddress(LPSTR buf, UINT cbbuf)
{
    RPC_STATUS RpcStat;
    UUID Uuid;
    BOOL ret = FALSE;

    if (cbbuf < 13)          // Card address is 12 character string
        return FALSE;

    RpcStat = UuidCreate(&Uuid);   // Create GUID
    if (RpcStat == RPC_S_OK) {
        unsigned char *tbuf;
        RpcStat = UuidToString(&Uuid, &tbuf);// Convert to a string
        if (RpcStat == RPC_S_OK) {
            // string is of form nnnn-nnnn-nnnn
            // last nnnn is card address
            char *ptr = strrchr((char *)tbuf,'-');
            if (ptr) {
                strcpy(buf, ptr+1);
                ret = TRUE; // It all worked !
            }
            // Need to free created buffer
            RpcStringFree(&tbuf);
        }
    }

    return ret;
}
