VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "SubClasser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Subclass a Windows window"
Option Explicit

'---- Event
Event WindowMessage(ByVal hwnd As Long, ByVal uMsg As Long, _
        ByVal wParam As Long, ByVal lParam As Long, _
        Result As Long, CallDefault As Boolean)

'---- Private data
Private m_hwnd As Long
Private fSubclassed As Boolean

'---- hwnd Property
Public Property Get hwnd() As Long
    hwnd = m_hwnd
End Property

'---- SubClass Method
Public Sub SubClass(hwnd As Long)
    ' Already subclassed?
    If fSubclassed Then
        Err.Raise Number:=33001, _
            Description:="Window is already subclassed"
        Exit Sub
    End If
    
    ' Checks valid hwnd
    If IsWindow(hwnd) = 0 Then
        Err.Raise Number:=33000, _
            Description:="hwnd is not a valid window handle"
        Exit Sub
    End If
    ' Stores hwnd
    m_hwnd = hwnd
    
    ' Subclasses
    modSubClass Me
    fSubclassed = True
End Sub

'---- ReClass Method
Public Sub ReClass()
    ' Checks already subclassed
    If Not fSubclassed Then
        Err.Raise Number:=33002, _
            Description:="Window is not subclassed"
        Exit Sub
    End If
    
    ' Removes subclassing
    modReClass Me
    fSubclassed = False
End Sub

'---- CallPrevWindowProc Method
Public Function CallPrevWindowProc(ByVal hwnd As Long, _
        ByVal uMsg As Long, ByVal wParam As Long, _
        ByVal lParam As Long) As Long
    CallPrevWindowProc = modCallPrevWindowProc(hwnd, _
                                    uMsg, wParam, lParam)
End Function

'---- Message from the Window Procedure
Friend Function Message(ByVal hwnd As Long, _
            ByVal uMsg As Long, ByVal wParam As Long, _
            ByVal lParam As Long, CallDefault As Boolean) As Long
    Dim Result As Long: Result = 0
    
    ' Fires WindowMessage event
    RaiseEvent WindowMessage(hwnd, uMsg, wParam, lParam, _
        Result, CallDefault)
    
    ' Result
    Message = Result
End Function

'---- Terminates
Private Sub Class_Terminate()
    If fSubclassed Then
        ' Removes subclassing
        modReClass Me
    End If
End Sub
