//
//  thread.cpp -- requires the multithreaded library.  Build with:
//      cl /MT thread.cpp /link user32.lib
//

#include <windows.h>
#include <process.h>

class CLeakTest {
private:
    TCHAR lpTitle[64];
    void Show(LPTSTR lpmsg) { 
        MessageBox(NULL,lpTitle,lpmsg,MB_OK|MB_ICONINFORMATION);
    }
public:
    CLeakTest(LPTSTR title){
        lstrcpy(lpTitle,title);
        Show(TEXT("CONSTRUCTOR called!"));
    }
    ~CLeakTest() {
        Show(TEXT("DESTRUCTOR called!"));
    }
};

unsigned WINAPI Leaky(LPVOID lpVoid)
{
    CLeakTest lk((LPTSTR)lpVoid);

    _endthreadex(0);
    return 0;
}

unsigned WINAPI No_Leak(LPVOID lpVoid)
{
    CLeakTest lk((LPTSTR)lpVoid);
    return 0;
}

int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    HANDLE handle;
    unsigned threadAddr;

    // Trying _beginthreadex/_endthreadex
    handle = (HANDLE)_beginthreadex(NULL,0,Leaky,
                        TEXT("Leaky - CALL"),0, &threadAddr);
    WaitForSingleObject(handle,INFINITE);
    CloseHandle(handle);

    handle = (HANDLE)_beginthreadex(NULL,0,No_Leak,
                        TEXT("No_Leak - CALL"),0, &threadAddr);
    WaitForSingleObject(handle,INFINITE);
    CloseHandle(handle);

    return 0;
}
// End of File
